macroScript TreeMatoGraph category:"Bobo_s Tools" buttontext:"TMG"
(

--------------------------------------------
--TreeMatoGraph 
--version 0.4.8 (Beta)
--Last Edited: 11/30/2002
--Copyright (c) 2002 by Borislav Petrov
--bobo@email.archlab.tuwien.ac.at
--http://www.scriptspot.com/bobo/darkmoon/tmg
--------------------------------------------

--New In 0.4.8:
--*Fixed Material Sample Rendering Speed in complex scenes

--New In 0.4.7:
--*Added support for MAXShade ShaderParameters QuickEditing
--*Made QuickEdit window wider to fit the ShaderParameters
--*Fixed infinite update loop after Options dialog
--*Removed Main Menu - use Right-click on background Context Menu 

--New In 0.4.6:
--*QuickEdit Properties Dialog 
--*Node Context Menu item for QuickEdit
--*[qe] UI option to open QuickEdit on node double-click instead of Material Editor.
--*Basic MAXShade support - 
----*show existing connections, 
----*unlink from MAXShade nodes, 
----*replace existing maps of MAXShade nodes, 
----*link MAXShade nodes to non-MAXShade nodes
----*(No way to connect to empty MAXShade nodes yet)
--*Fixed bug in Avguard DLX detection - the DLX was never used when the shipping 5.0.2 was installed 
--(I used a pre-prelease 4.01 which was detected correctly... Thanks to Harrie Dechering!)
--*Fixed tree topology changes update callback - in 0.4.5 only, adding nodes in MEdit did not update.
--*Fixed shaded color update on single node updates

--New In 0.4.5:
--*Unlink From All Parents in context menu
--*Fixed labels display when more nodes than labels
--*Implemented support for all 100 UVW Channels and the Vertex Color channel
--*Fixed crasher when deleting nodes from MultiMaterial tree
--*Changed redraw code to use Progressive Update only

--New In 0.4.4:
--*Progressive Update + Edit>Options Progressive Update settings
--*Collapse/Expand Downstream (Ctrl+Left Doubleclick)
--*Collapse/Expand/Expand All in Node Context Menu items
--*Multiple selection moving up to 2x faster
--*Fixed Window Selection in scaled mode
--*Update Bitmaps before thumbnails update
--*Horizontal/Vertical order in view + Edit>Options Order settings
--*Clone Node (Shift+LeftClick+Drag)
--*Delete Node deletes only the current node and keeps unlinked nodes

--New In 0.4.3:
--*Optimized control bar.
--*Optimized Main Menu
--*New Zoom Main Menu Item with new Zoom All, Zoom Selected and Reset Pan & Zoom commands
--*Added Alt+LMB Add To Selection Mode - existing Selected Nodes will not be deselected 
--*New UI Icons - copy file TMG_ICONS.BMP to your \UI\ICONS subdirectory!
--*New buttons for Zoom Region, Zoom Selected and Zoom All

--New In 0.4.2:
--*Fixed a bug that has been around since 0.3.5 (and nobody has reported it) - SubMaterials of Multi/Subs were not shown.
--*Ctrl+MMB resets Zoom to 100%
--*Changed Compact Node Arrangement to shift every even row at 1/2 node size for better links display
--*Fixed a new crasher when moving a node with Diagonal links

--New In 0.4.1:
--*Added TMG Console with session history -  click Status bar in lower right corner!
--*New MainMenu>Display>Thumbnail options. These change the Quality vs. Speed settings 
--found under Options. "Quick&Dirty" is ugly but very fast, "Good & Fast" is great for most cases.
--*Fixed some more bugs. Probably added some new ones...

--New In 0.4.0:
--*View Scaling Controls (Real Zoom)
--*Interactive Zoom with Ctrl+LMB = Zoom Window, Ctrl + MMB = Zoom Up/Down rel. to Origin.
--*Origin symbol as red cross for reference
--*Added Support for Darkling Simulation's SimbiontMax Procedural Materials and Maps 
--*Added switch for Missing Maps Rendering under Options - SimbiontMax triggers the missing map check, 
--so I needed an override.
--*Fixed problem with partial INI loading between MAX Sessions.
--*Fixed more bugs, bumped version number up to 0.4

--*SEE TMG HOMEPAGE FOR OLDER VERSION NOTES...

--TODO:
--*Multiple Roots support


global TreeMatoGraph_rollout

global TreeMatoGraph_Nodes 
global TreeMatoGraph_Links 
global TreeMatoGraph_options_floater

global TMG_target_map
global TMG_source_map
global TMG_t_map
global TMG_s_map 

global TreeMatoGraph_Currently_Edited_Tree 

------------
--UI ICONS--
------------
local tmg_move_icon = bitmap (16*2) 16
local tmg_pan_icon = bitmap (16*2) 16
local tmg_zoom_icon = bitmap (16*2) 16
local tmg_mag_icon = bitmap (16*2) 16
local tmg_del_icon = bitmap (16*2) 16
local tmg_link_icon = bitmap (16*2) 16
local tmg_unlink_icon = bitmap (16*2) 16
local tmg_zoomwin_icon = bitmap (16*2) 16
local tmg_zoomsel_icon = bitmap (16*2) 16
local tmg_zoomall_icon = bitmap (16*2) 16
local tmg_zoomreset_icon = bitmap (16*2) 16

------------------
--INIT. UI ICONS--
------------------
try
(
local icons_bitmap = openBitmap ((GetDir #ui)+"/icons/tmg_icons.bmp")
for i = 0 to 15 do
(
	pixels = getPixels icons_bitmap [0,i] 32
    setPixels tmg_move_icon [0,i] pixels 

	pixels = getPixels icons_bitmap [(16*2),i] 32
    setPixels tmg_pan_icon [0,i] pixels 
	
	pixels = getPixels icons_bitmap [(16*4),i] 32
    setPixels tmg_zoom_icon [0,i] pixels 

	pixels = getPixels icons_bitmap [(16*6),i] 32
    setPixels tmg_mag_icon [0,i] pixels 
	
	pixels = getPixels icons_bitmap [(16*8),i] 32
    setPixels tmg_del_icon [0,i] pixels 

	pixels = getPixels icons_bitmap [(16*10),i] 32
    setPixels tmg_link_icon [0,i] pixels 

	pixels = getPixels icons_bitmap [(16*12),i] 32
    setPixels tmg_unlink_icon [0,i] pixels 

	pixels = getPixels icons_bitmap [(16*14),i] 32
    setPixels tmg_zoomwin_icon [0,i] pixels 	

	pixels = getPixels icons_bitmap [(16*16),i] 32
    setPixels tmg_zoomsel_icon [0,i] pixels 	

	pixels = getPixels icons_bitmap [(16*18),i] 32
    setPixels tmg_zoomall_icon [0,i] pixels 	

	pixels = getPixels icons_bitmap [(16*20),i] 32
    setPixels tmg_zoomreset_icon [0,i] pixels 	
)
close  icons_bitmap
)
catch()


local TreeMatoGraph_Links_Map = #()
local graph_width = 600
local graph_height = 400
local new_graph_width = 600
local new_graph_height = 400
local InitUtilityDialog
local ready_to_resize = false
local root_sample_object = 1

local first_start = true
local useAvguardExtension = false
local AvguardExtensionInstalled 
try(AvguardExtensionInstalled = avguard_dlx_ver != undefined )catch(AvguardExtensionInstalled = false)
local Disable_UseAvguardExtension = false
	
local background_color = (color 150 150 170)
local thumb_width = 32
local thumb_height = 32
local thumb_hspacing = 15
local thumb_vspacing = 15
local zoom_factor = 3.0
local zoom_quality = 0.5

local scale_factor = 1.0

local draw_node_shadows = 3
local node_shadow_density = 50.0

local show_lines_while_moving = false
local link_shaded_override = true
local show_shaded_while_moving = false
local show_tooltip_on_rollover = false
local show_ghost_nodes = true
local quickdraw_skip_lines = 4
local link_parent_color = color 255 255 255
local link_child_color = color 0 0 100
local link_link_color = color 0 220 0
local link_unlink_color = color 200 0 50
local link_input_color = color 255 255 0
local link_output_color = color 220 0 0
local selection_window_color = color 255 0 0

local link_display_mode = 2
local link_arrow_size = 5

local right_click_behavior = 2

local map_bmp
local map_sample = bitmap thumb_width thumb_height
local map_to_draw
local shadow_to_draw
local LButtonPressed = false
local MButtonPressed = false
local RButtonPressed = false
local current_node = 0
local clip_offset = Point2 0 0
local pan_offset = Point2 0 0
local origin_offset = Point2 0 0
local start_pos = Point2 0 0
local already_used_array = #()
local already_used_index = #()
local collect_nodes = #()
local lights_array = #()
local lights_state = #()
local Thumb_label = #()
local Type_label = #()
local display_map_array = #()
local target_slots
local collectMapSlots 
local linked_slots
local type_counter = 0
local current_highlight = 0
local last_scale_pos = [0,0]
local disableMissingMaps = false
local quickEditEnabled = false

local show_node_names_state = true
local show_node_class_state = true
local show_parent_channel_state = true
local show_child_channel_state = true
local auto_update_state = false

local node_to_rename = undefined

local multiple_selection = #()
local multiple_selection_start 
local multiple_selection_end 
local multiple_selection_mode = false

local start_move_pos 

local old_node_positions = #()
local store_old_nodes = #()
local lonely_nodes = #()

local progressive_update_passes = 3
local progressive_update_current_pass = 1
local progressive_update_current_node = 0

local view_order = 1

local TreeMatoGraph_PropertyChanged = 10^10
local TreeMatoGraph_StructureChanged = false
local TreeMatoGraph_LastPropertyChange = 10^10
local LastThumbnailUpdateTime = 1000.0

local TreeMatoGraph_Undo_Buffer = undefined

global requiredMappingChannles = #()

local old_pos = [0,0]
local connect_source_node = 0
local ConnectMode = false
local DisconnectMode = false

local UiLog_history = #("Initializing TreeMatoGraph...")

struct tree_node (Name, XPos, YPos, Width, Height, ShadedColor, Thumbnail, MaxNode, Row, Column, Selected=False, Renderable=True, IsRoot=False, Collapsed=False, Visible=True, ReqMapCoords=-1 )

local storeIniFile
local restoreIniFile

fn storePosition pos =
(
	setIniFile = CreateFile ((GetDir #plugcfg)+"/TreeMatoGraphPosition.ini")
	format "%\n" pos to:setIniFile 
	close setIniFile 	
)

fn restorePosition =
(
	getIniFile = OpenFile ((GetDir #plugcfg)+"/TreeMatoGraphPosition.ini")
	if getIniFile != undefined then
	(
		try
		(
			pos = execute ( readLine getIniFile )
			close getIniFile 	
		)
		catch
		(
			pos = [200, 200]
		)
	)	
	else
	(
		pos = [200, 200]
	)
pos 	
)

fn storeAppDataVisible =
(
	app_data_start = 20020515
	for n in TreeMatoGraph_Nodes do
	(
		setAppData n.MaxNode (app_data_start+4) (n.Visible as string)
		setAppData n.MaxNode (app_data_start+5) (n.Collapsed as string)
	)	
)	

fn restoreAppDataVisible node_record =
(
	app_data_start = 20020515
	try(Execute( getAppData node_record.MaxNode (app_data_start+4)))catch(true)
)

fn restoreAppDataCollapsed node_record =
(
	app_data_start = 20020515
	try(Execute( getAppData node_record.MaxNode (app_data_start+5)))catch(false)
)

fn setChangedPropertyFlag =
(
	TreeMatoGraph_PropertyChanged = timestamp()
)

fn setChangedStructureFlag =
(
	TreeMatoGraph_StructureChanged = true
)

fn unregisterMaterialPropertiesCallback =
(
	deleteAllChangeHandlers id:#TreeMatoGraph_When
)

fn registerMaterialPropertiesCallback =
(
	unregisterMaterialPropertiesCallback()
	try
	(
		when parameters TreeMatoGraph_Currently_Edited_Tree changes id:#TreeMatoGraph_When do setChangedPropertyFlag()
	)
	catch()	
	try
	(
		when subAnimStructure TreeMatoGraph_Currently_Edited_Tree changes id:#TreeMatoGraph_When do setChangedStructureFlag()
	)
	catch()	
)

fn storeIniFile =
(
	setIniFile = CreateFile ((GetDir #plugcfg)+"/TreeMatoGraph.ini")
	format "%\n" background_color to:setIniFile 
	format "%\n" thumb_width to:setIniFile 
	format "%\n" thumb_height to:setIniFile 
	format "%\n" thumb_hspacing to:setIniFile 
	format "%\n" thumb_vspacing to:setIniFile 
	format "%\n" show_lines_while_moving to:setIniFile 
	format "%\n" show_shaded_while_moving to:setIniFile 
	format "%\n" show_tooltip_on_rollover to:setIniFile 
	format "%\n" show_ghost_nodes to:setIniFile 
	format "%\n" quickdraw_skip_lines to:setIniFile 
	format "%\n" link_parent_color to:setIniFile 
	format "%\n" link_child_color to:setIniFile 
	format "%\n" link_display_mode to:setIniFile 
	format "%\n" link_arrow_size to:setIniFile 
	format "%\n" TreeMatoGraph_rollout.show_node_names.state to:setIniFile 
	format "%\n" TreeMatoGraph_rollout.show_node_class.state to:setIniFile 
	format "%\n" TreeMatoGraph_rollout.show_parent_channel.state to:setIniFile 
	format "%\n" TreeMatoGraph_rollout.show_child_channel.state to:setIniFile 
	format "%\n" link_link_color to:setIniFile 
	format "%\n" link_unlink_color to:setIniFile 
	format "%\n" link_output_color to:setIniFile 
	format "%\n" link_input_color to:setIniFile 
	format "%\n" selection_window_color to:setIniFile 
	format "%\n" graph_width to:setIniFile 
	format "%\n" graph_height to:setIniFile 
	format "%\n" zoom_factor to:setIniFile 
	format "%\n" zoom_quality to:setIniFile 
	format "%\n" TreeMatoGraph_rollout.auto_update.state to:setIniFile 
	format "%\n" root_sample_object to:setIniFile 
	format "%\n" link_shaded_override to:setIniFile 
	format "%\n" right_click_behavior to:setIniFile 
	format "%\n" Disable_UseAvguardExtension to:setIniFile 
	format "%\n" draw_node_shadows to:setIniFile 
	format "%\n" node_shadow_density to:setIniFile 
	format "%\n" disableMissingMaps to:setIniFile 
	format "%\n" view_order to:setIniFile 
	format "%\n" progressive_update_passes to:setIniFile 
	format "%\n" quickEditEnabled to:setIniFile 
	 
	close setIniFile 
)	

fn restoreIniFile =
(
	if first_start then append UiLog_history ">TMG Loading Settings..."
	getIniFile = OpenFile ((GetDir #plugcfg)+"/TreeMatoGraph.ini")
	if getIniFile != undefined then
	(
		try
		(
			background_color = execute ( readLine getIniFile )
			thumb_width = execute ( readLine getIniFile )
			thumb_height = execute ( readLine getIniFile )
			thumb_hspacing = execute ( readLine getIniFile )
			thumb_vspacing = execute ( readLine getIniFile )
			show_lines_while_moving = execute ( readLine getIniFile )
			show_shaded_while_moving = execute ( readLine getIniFile )
			show_tooltip_on_rollover = execute ( readLine getIniFile )
			show_ghost_nodes = execute ( readLine getIniFile )
			quickdraw_skip_lines = execute ( readLine getIniFile )
			link_parent_color = execute ( readLine getIniFile )
			link_child_color = execute ( readLine getIniFile )
			link_display_mode = execute ( readLine getIniFile ) 
			link_arrow_size = execute ( readLine getIniFile ) 
			show_node_names_state = execute ( readLine getIniFile ) 
			show_node_class_state = execute ( readLine getIniFile ) 
			show_parent_channel_state = execute ( readLine getIniFile ) 
			show_child_channel_state = execute ( readLine getIniFile ) 
			link_link_color = execute ( readLine getIniFile )
			link_unlink_color = execute ( readLine getIniFile )
			link_output_color = execute ( readLine getIniFile )
			link_input_color = execute ( readLine getIniFile )
			selection_window_color = execute ( readLine getIniFile )
			graph_width = execute ( readLine getIniFile )
			graph_height = execute ( readLine getIniFile )
			zoom_factor = execute ( readLine getIniFile )
			zoom_quality = execute ( readLine getIniFile )
			auto_update_state = execute ( readLine getIniFile ) 
			root_sample_object = execute ( readLine getIniFile )
			link_shaded_override = execute ( readLine getIniFile )
			right_click_behavior = execute ( readLine getIniFile )
			disable_UseAvguardExtension  = execute ( readLine getIniFile )
			draw_node_shadows = execute ( readLine getIniFile )
			node_shadow_density = execute ( readLine getIniFile )
			disableMissingMaps = execute ( readLine getIniFile )
			view_order = execute ( readLine getIniFile )
			progressive_update_passes = execute ( readLine getIniFile )
			quickEditEnabled = execute ( readLine getIniFile )
		)
		catch(append UiLog_history ("-TMG Settings Outdated, assuming defaults for some settings...") )	
		close getIniFile 
	)	
	UseAvguardExtension = true
	if Disable_UseAvguardExtension then UseAvguardExtension = false
	if AvguardExtensionInstalled then 
	(
		if first_start then 
			append UiLog_history ("+Avguard DLX Version "+ avguard_dlx_ver as string +" Detected.")
	)	
	else
	(
		UseAvguardExtension = false
	)
	
	if first_start then 
	(
		if UseAvguardExtension then
			append UiLog_history "+TMG Using Avguard DLX."
		else
			append UiLog_history "+TMG Using Plain Vanilla MAXScript."
		append UiLog_history "+TMG Settings Loaded."
		first_start = false
	)
	
)
restoreIniFile()

local graph_bmp 
local background_plane 
local back_plane 

fn InitializeGraphicsWindow =
(
	graph_bmp = bitmap graph_width graph_height color:background_color 
	background_plane = bitmap graph_width  graph_height color:background_color 
	back_plane = bitmap graph_width graph_height color:background_color 
)

InitializeGraphicsWindow()

fn store_old_positions =
(
	old_node_positions = #()
	store_old_nodes = #()
	lonely_nodes = #()
	for i = 1 to TreeMatoGraph_Nodes.count do
	(
		append store_old_nodes TreeMatoGraph_Nodes[i].MaxNode
		append old_node_positions (point2 TreeMatoGraph_Nodes[i].XPos TreeMatoGraph_Nodes[i].YPos)
		item_found = false
		for l in TreeMatoGraph_Links do
		(
			if l[1] == i or l[2] == i then
			(
				item_found = true
			)
		)
		if not item_found then
		(
			append lonely_nodes TreeMatoGraph_Nodes[i]
		)
	)
)

fn restore_old_positions =
(
	for i in TreeMatoGraph_Nodes do
	(
		find_index = findItem store_old_nodes i.MaxNode
		if find_index > 0 then
		(
			i.XPos = old_node_positions[find_index].x
			i.YPos = old_node_positions[find_index].y
		)	
		for j = lonely_nodes.count to 1 by -1 do
		(
			if lonely_nodes[j].MaxNode == i.MaxNode then deleteItem lonely_nodes j
		)
	)
	for i in lonely_nodes do
	(
		append TreeMatoGraph_Nodes i
	)
)

fn restore_old_lonely_positions =
(
	for i in TreeMatoGraph_Nodes do
	(
		for j = lonely_nodes.count to 1 by -1 do
		(
			if lonely_nodes[j].MaxNode == i.MaxNode then deleteItem lonely_nodes j
		)
	)
	for i in lonely_nodes do
	(
		append TreeMatoGraph_Nodes i
	)
)


fn CreateUndoBuffer =
(
	TreeMatoGraph_Undo_Buffer = undefined
	try
	(
		TreeMatoGraph_Undo_Buffer = copy TreeMatoGraph_Currently_Edited_Tree 
		TreeMatoGraph_Undo_Buffer.name = TreeMatoGraph_Currently_Edited_Tree.name
	)
	catch()	
)--end fn


fn RestoreUndoBuffer =
(

/*
	if TreeMatoGraph_Undo_Buffer  != undefined then
	(
		TreeMatoGraph_Currently_Edited_Tree = TreeMatoGraph_Undo_Buffer
		TreeMatoGraph_rollout.buildTree TreeMatoGraph_Currently_Edited_Tree 
		TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane 0 1 1 1
		TreeMatoGraph_rollout.UiLog ("Undone Last Changes") 2
		TreeMatoGraph_rollout.displayNodeNames()
	)	
	else
	(
		TreeMatoGraph_rollout.UiLog ("Cannot Undo!") 4
	)
*/	
	TreeMatoGraph_rollout.UiLog ("Undo is DISABLED in this version.") 4
	
)--end fn

--Check for Missing Maps

local missingMaps = #()
fn enumeratefn name = (append missingMaps name)
fn checkForMissingMaps =
(
	missingMaps = #()
	enumerateFiles enumeratefn #missing 
	if disableMissingMaps then missingMaps.count > 0 else false
)	

-----------------------
-- QuickEdit Rollout --
-----------------------

local TreeMatoGraph_quickEdit_rollout
local EditablePropertiesList = #()
local last_current_node 

fn CollectEditableProperties type_mode =
(
	EditablePropertiesList = #()
	local max_node = TreeMatoGraph_Nodes[last_current_node].MaxNode
	strs = StringStream ""
	showProperties max_node to:strs
	seek strs 0
	while not eof strs do
	(
		str = readLine strs 
		case type_mode of
		(
			1:	strpos = findstring str ": RGB color" 
			2:	strpos = findstring str ": float" 
			3:	strpos = findstring str ": integer" 
			4:	strpos = findstring str ": percentage" 
			5:	strpos = findstring str ": boolean" 
		)
		if strpos != undefined then 
		(
			startpos = findstring str "." 
			str = substring str (startpos+1) 1000
			endpos = findstring str " " 
			str = substring str 1 (endpos-1)
			append EditablePropertiesList str
		)	
	)
	close strs

	try
	(
		prop_names = getPropNames max_node.shader_parameters 
		for p in prop_names do
		(
			prop = getProperty max_node.shader_parameters p 
			case type_mode of
			(
				1:	if classof prop == Color then append EditablePropertiesList ("shader_parameters."+ p as string)
				2:	if classof prop == Float then append EditablePropertiesList ("shader_parameters."+p as string)
				3:	if classof prop == Integer then append EditablePropertiesList ("shader_parameters."+p as string)
			)
		)--end p
	)
	catch()	
	
	sort EditablePropertiesList 
)

fn QuickEdit_UpdateCurrentValue =
(
	try
	(
		TMG_target_map = TreeMatoGraph_Nodes[last_current_node].MaxNode
		local txt = "TMG_target_map."+ TreeMatoGraph_quickEdit_rollout.props_list.selected 
		local val = execute (txt)
		case TreeMatoGraph_quickEdit_rollout.props_type.selection of
		(
			1: TreeMatoGraph_quickEdit_rollout.edit_color.color = val
			2: TreeMatoGraph_quickEdit_rollout.edit_float.value= val
			3: TreeMatoGraph_quickEdit_rollout.edit_integer.value= val
			4: TreeMatoGraph_quickEdit_rollout.edit_percent.value = val
			5: TreeMatoGraph_quickEdit_rollout.edit_boolean.state= val
		)
	)
	catch()	
)

rollout TreeMatoGraph_quickEdit_rollout "TMG QuickEdit:"
(
	edittext node_name width:200 align:#center pos:[-2,2]
	listbox props_type height:5 items:#("Colors","Floating Point Values","Integer Values","Percentages","Boolean Switches") width:200 pos:[0,20]
	colorpicker edit_color pos:[10,96] width:180 
	spinner edit_float 		range:[0,100,0] pos:[1000,1000] fieldwidth:50 align:#right
	spinner edit_integer 	range:[0,100,0] type:#integer pos:[1000,1000] fieldwidth:50 
	spinner edit_percent 	range:[0,100,0] type:#integer pos:[1000,1000] fieldwidth:50 
	checkbutton edit_boolean "Toggle" pos:[1000,1000] width:180 align:#right
	
	listbox props_list height:21 width:200 pos:[0,120]
	
	on props_list selected itm do QuickEdit_UpdateCurrentValue()
	
	on props_type selected itm do 
	(
		props_list.selection = 1
		props_list.items = collectEditableProperties itm
		case itm of
		(
			1: (
				edit_color.pos = [10,96]
				edit_float.pos = [1000,1000]
				edit_integer.pos = [1000,1000]
				edit_percent.pos = [1000,1000]
				edit_boolean.pos = [1000,1000]
				edit_color.enabled = props_list.items.count > 0
				)
			2: (
				edit_color.pos = [1000,1000]
				edit_float.pos = [60,100]
				edit_integer.pos = [1000,1000]
				edit_percent.pos = [1000,1000]
				edit_boolean.pos = [1000,1000]
				edit_float.enabled = props_list.items.count > 0
				)
			3: (
				edit_color.pos = [1000,1000]
				edit_float.pos = [1000,1000]
				edit_integer.pos = [60,100]
				edit_percent.pos = [1000,1000]
				edit_boolean.pos = [1000,1000]
				edit_integer.enabled = props_list.items.count > 0
				)
			4: (
				edit_color.pos = [1000,1000]
				edit_float.pos = [1000,1000]
				edit_integer.pos = [1000,1000]
				edit_percent.pos = [60,100]
				edit_boolean.pos = [1000,1000]
				edit_percent.enabled = props_list.items.count > 0
				)
			5: (
				edit_color.pos = [1000,1000]
				edit_float.pos = [1000,1000]
				edit_integer.pos = [1000,1000]
				edit_percent.pos = [1000,1000]
				edit_boolean.pos = [10,95]
				edit_boolean.enabled = props_list.items.count > 0
				)
		)--end case
		QuickEdit_UpdateCurrentValue()		
	)--end on

	fn changeHandlerUpdate val =
	(
		try
		(
			TMG_target_map = TreeMatoGraph_Nodes[last_current_node].MaxNode
			txt = "TMG_target_map."+ props_list.selected +"="+ val as string
			execute (txt)
			TreeMatoGraph_PropertyChanged = timestamp()
		)catch()			
	)
	
	on edit_color changed val do changeHandlerUpdate val
	on edit_float changed val do changeHandlerUpdate val
	on edit_integer changed val do changeHandlerUpdate val
	on edit_percent changed val do changeHandlerUpdate val
	on edit_boolean changed val do changeHandlerUpdate val
)

fn OpenQuickEdit =
(
	DestroyDialog TreeMatoGraph_quickEdit_rollout
	local new_pos = restorePosition()
	CreateDialog TreeMatoGraph_quickEdit_rollout 200 400 (new_pos.x+graph_width+7) (new_pos.y)
	last_current_node = current_node
	TreeMatoGraph_quickEdit_rollout.props_list.items = collectEditableProperties 1
	TreeMatoGraph_quickEdit_rollout.node_name.text = TreeMatoGraph_Nodes[last_current_node].MaxNode.name + " ["+ (classof TreeMatoGraph_Nodes[last_current_node].MaxNode) as string +"]"
	QuickEdit_UpdateCurrentValue()
)

rcMenu TMG_NodeRichtClick
(
	menuItem tmg_nrc_edit 		"Edit in Material Editor"
	menuItem tmg_nrc_quickedit 	"QuickEdit"
	
	separator tmp_nrc_sep2

	subMenu "Link"
	(
		menuItem tmg_nrc_link 		"Link"
		menuItem tmg_nrc_unlink		"Unlink"
		separator tmp_nrc_sep4
		menuItem tmg_nrc_unlinkall	"Unlink From All Parents"
	)

	separator tmp_nrc_sep6
	
	menuItem tmg_nrc_move 		"Move"
	menuItem tmg_nrc_zoom		"Magnify"
	menuItem tmg_nrc_select		"Select"
	menuItem tmg_nrc_deselect	"Deselect"
	
	separator tmp_nrc_sep8
	
	subMenu "Disable Thumbnail"
	(	
		menuItem tmg_nrc_disable	"Disable Selected Thumbnails"	
		menuItem tmg_nrc_update 	"Enable/Update Selected Thumbnails"
	)	
	
	separator tmp_nrc_sep10

	subMenu "Collapse"
	(
		menuItem tmg_nrc_collapse	"Collapse Children"
		menuItem tmg_nrc_expand 	"Expand Children"
		menuItem tmg_nrc_expandAll 	"Expand Complete Branch"
	)	
	
	separator tmp_nrc_sep12

	subMenu "Show Map In Viewport"
	(
		menuItem tmg_nrc_smiv		"Show Map In Viewport"
		menuItem tmg_nrc_unsmiv		"Hide Map In Viewport"
	)
	
	separator tmp_nrc_sep14
	menuItem tmg_nrc_delete 	"Delete"
	
	
	on tmg_nrc_quickedit picked do
	(
		OpenQuickEdit()
	)
	
	on tmg_nrc_collapse picked do
	(
		TreeMatoGraph_Nodes[current_node].Collapsed = True
		TreeMatoGraph_rollout.CollapseTree()
		storeAppDataVisible ()
	)

	on tmg_nrc_expand picked do
	(
		TreeMatoGraph_Nodes[current_node].Collapsed = False
		TreeMatoGraph_rollout.ExpandTree()
		storeAppDataVisible ()
	)	
	
	on tmg_nrc_expandAll picked do
	(
		TreeMatoGraph_Nodes[current_node].Collapsed = False
		TreeMatoGraph_rollout.ExpandBranch current_node
		storeAppDataVisible ()
	)	
	
	on tmg_nrc_disable picked do
	(
		if TreeMatoGraph_Nodes[current_node].Selected then
		(
			for n in TreeMatoGraph_Nodes do
			(
				if n.Selected then
				(
					n.Renderable = false
					TreeMatoGraph_rollout.storeAppDataRenderable n
					map_sample = bitmap  n.Width n.Height color:n.ShadedColor
					n.Thumbnail = map_sample
				)	
			)
		)
		else
		(
			TreeMatoGraph_Nodes[current_node].Renderable = false
			TreeMatoGraph_rollout.storeAppDataRenderable TreeMatoGraph_Nodes[current_node]
			map_sample = bitmap TreeMatoGraph_Nodes[current_node].Width TreeMatoGraph_Nodes[current_node].Height color:TreeMatoGraph_Nodes[current_node].ShadedColor
			TreeMatoGraph_Nodes[current_node].Thumbnail = map_sample
		)	
	)
	
	on tmg_nrc_smiv picked do 
	(
		try
		(
			if superclassof TreeMatoGraph_Nodes[current_node].MaxNode == Material then
				showTextureMap TreeMatoGraph_Nodes[current_node].MaxNode true
			else
				showTextureMap TreeMatoGraph_Nodes[1].MaxNode TreeMatoGraph_Nodes[current_node].MaxNode true
		)catch()	
	)	
	on tmg_nrc_unsmiv picked do 
	(
		try
		(
			if superclassof TreeMatoGraph_Nodes[current_node].MaxNode == Material then 
				showTextureMap TreeMatoGraph_Nodes[current_node].MaxNode false
			else	
				showTextureMap TreeMatoGraph_Nodes[1].MaxNode TreeMatoGraph_Nodes[current_node].MaxNode false
		)catch()	
	)	
	
	on tmg_nrc_edit picked do TreeMatoGraph_rollout.LoadNodeInMeditor current_node 
	
	on tmg_nrc_update picked do 
	(
		if TreeMatoGraph_Nodes[current_node].Selected then
		(
			for n = 1 to TreeMatoGraph_Nodes.count do
			(
				if TreeMatoGraph_Nodes[n].Selected then
				(
					TreeMatoGraph_Nodes[n].Renderable = true
					TreeMatoGraph_rollout.UpdateSingleNodeThumbnail n zoom_quality
				)
			)
		)
		else
		(	
			TreeMatoGraph_Nodes[current_node].Renderable = true
			TreeMatoGraph_rollout.UpdateSingleNodeThumbnail current_node zoom_quality
		)	
	)	
	on tmg_nrc_delete picked do	TreeMatoGraph_rollout.deleteNodeFromTree current_node 
	on tmg_nrc_unlinkall picked do	TreeMatoGraph_rollout.UnlinkNodeFromTree current_node 
	
	
	on tmg_nrc_move picked do 
	(
		TreeMatoGraph_rollout.move_mode.checked = true
		TreeMatoGraph_rollout.link_mode.checked = TreeMatoGraph_rollout.unlink_mode.checked = TreeMatoGraph_rollout.zoom_mode.checked = TreeMatoGraph_rollout.pan_mode.checked = TreeMatoGraph_rollout.del_mode.checked = TreeMatoGraph_rollout.zoomwin_mode.checked = false
	)	
	on tmg_nrc_link picked do
	(
		TreeMatoGraph_rollout.link_mode.checked = true
		TreeMatoGraph_rollout.move_mode.checked = TreeMatoGraph_rollout.unlink_mode.checked = TreeMatoGraph_rollout.zoom_mode.checked = TreeMatoGraph_rollout.pan_mode.checked = TreeMatoGraph_rollout.del_mode.checked = TreeMatoGraph_rollout.zoomwin_mode.checked = false
        TreeMatoGraph_rollout.InitializeLinking current_node 		
	)
	on tmg_nrc_unlink picked do
	(
		TreeMatoGraph_rollout.unlink_mode.checked = true
		TreeMatoGraph_rollout.move_mode.checked = TreeMatoGraph_rollout.link_mode.checked = TreeMatoGraph_rollout.zoom_mode.checked = TreeMatoGraph_rollout.pan_mode.checked = TreeMatoGraph_rollout.del_mode.checked = TreeMatoGraph_rollout.zoomwin_mode.checked = false
        TreeMatoGraph_rollout.InitializeUnlinking current_node 		
	)
	
	on tmg_nrc_select picked do
	(
		TreeMatoGraph_Nodes[current_node].Selected = True
		multiple_selection = #()
		for i = 1 to TreeMatoGraph_Nodes.count do if TreeMatoGraph_Nodes[i].Selected then append multiple_selection i
	)	
	on tmg_nrc_deselect picked do
	(
		TreeMatoGraph_Nodes[current_node].Selected = False
	)	
	on tmg_nrc_zoom picked do 
	(
		TreeMatoGraph_rollout.zoom_mode.checked = true
		TreeMatoGraph_rollout.link_mode.checked = TreeMatoGraph_rollout.unlink_mode.checked = TreeMatoGraph_rollout.move_mode.checked = TreeMatoGraph_rollout.pan_mode.checked = TreeMatoGraph_rollout.del_mode.checked = TreeMatoGraph_rollout.zoomwin_mode.checked =false
	)	
)

	rollout TreeMatoGraph_options_rollout "General Options"
	(
			button save_preset "Save Preset..." align:#left width:110 across:2
			button load_preset "Load Preset..." align:#right width:110 
/*	
		group "Graphics Window:"
		(
			spinner  options_graph_width	"Width: "	range:[600,1000,graph_width] 		type:#integer fieldwidth:35 align:#left across:2
			spinner  options_graph_height	"Height:"	range:[200,800,graph_height] 		type:#integer fieldwidth:35 align:#right
		)
*/
	
		group "Thumbnails:"
		(
			dropdownlist root_sample items:#("Sphere", "Box", "Cylinder", "Teapot" ) selection:root_sample_object across:3 align:#left width:80
			dropdownlist options_draw_node_shadows items:#("No Shadow","Flat Shadow","3D Shadow") align:#center selection:draw_node_shadows  width:90 offset:[20,0]
			spinner  options_shadow_density	""	range:[0,100,node_shadow_density] 	type:#float fieldwidth:35 align:#right offset:[0,2]
			
			spinner  options_thumb_width	"Width: "		range:[5,100,thumb_width] 		type:#integer fieldwidth:35 align:#left across:2
			spinner  options_spacing_width	"H Spacing:"	range:[1,100,thumb_hspacing] 	type:#integer fieldwidth:35 align:#right 
			spinner  options_thumb_height	"Height:"	    range:[5,100,thumb_height] 		type:#integer fieldwidth:35 align:#left across:2
			spinner  options_spacing_height	"V Spacing:"	range:[1,100,thumb_vspacing]	type:#integer fieldwidth:35 align:#right
			spinner  options_zoom_factor	"Zoom: "   		range:[1.0,10.0,zoom_factor] 	type:#float   fieldwidth:35 align:#left across:2
			spinner  options_zoom_quality	"Zoom Quality: "	range:[0.1,1.0,zoom_quality] 	type:#float   fieldwidth:35 align:#right
			checkbutton options_disableMissingMaps "Disable Update On Missing Maps" checked:disableMissingMaps width:225 highlightcolor:(color 200 255 200)
			dropdownlist options_view_order items:#("Compact Top-To-Bottom", "Compact Left-To-Right") selection:view_order align:#center
			spinner options_progressive_update_passes "Progressive Update Passes" range:[1,4,progressive_update_passes] type:#integer fieldwidth:35 align:#left offset:[0,2]
		)
		
		group "Panning Performance:"
		(
			checkbutton options_ignore_dlx	"Disable Avguard Extensions" width: 225 height:18 align:#center checked:Disable_UseAvguardExtension	enabled:(AvguardExtensionInstalled)	highlightcolor:(color 200 255 200)
			checkbutton options_show_lines 	"No Links" 			checked:(not show_lines_while_moving)	width: 110 height:18 across:2 align:#left 						highlightcolor:(color 200 255 200)
			checkbutton options_show_shaded "Shaded Nodes" 		checked:show_shaded_while_moving 		width: 110 height:18 enabled:(not AvguardExtensionInstalled or disable_UseAvguardExtension) align:#right 		highlightcolor:(color 200 255 200)
			checkbutton options_ghost		"Ghost Nodes" 		checked:show_ghost_nodes 				width: 110 height:18 enabled:(not AvguardExtensionInstalled or disable_UseAvguardExtension) across:2 align:#left 	highlightcolor:(color 200 255 200)
			spinner  options_ghost_nth 		"Ghost Nth Line:"	range:[2,10,quickdraw_skip_lines] 		type:#integer fieldwidth:22 offset:[0,1] enabled:(not AvguardExtensionInstalled or disable_UseAvguardExtension) align:#right
		)
		group "Links Options"
		(
			dropdownlist link_display		items:#("Diagonal Links","Straight Auto","Straight Horizontal","Straight Vertical") selection:(link_display_mode) width:120 across:2 align:#left offset:[-2,-2]
			spinner arrow_size "Arrow Size:" range:[3,15,link_arrow_size] fieldwidth:30 align:#right type:#integer
			dropdownlist options_right_click_behavior items:#("Ctrl+LC=Link,Alt+LC=Unlink,RC=Menu","RC=Link,Alt+RC=Unlink,Ctrl+RC=Menu" ) selection:right_click_behavior
		)
		
		button cancel_options "CANCEL" align:#left width:110 height:25 across:2
		button close_options "OK" align:#right width:110 height:25
	
		on options_view_order selected itm do view_order = itm
		on options_progressive_update_passes changed val do progressive_update_passes = val
		
		on save_preset pressed do
		(
			new_file = getSaveFileName filename:((GetDir #plugcfg)+"/TMG_Preset.tmg") types:"TreeMatoGraph Presets *.tmg |*.tmg"
			if new_file != undefined then
			(
				deleteFile ((GetDir #plugcfg)+"/TreeMatoGraph.tmp")
				copyfile ((GetDir #plugcfg)+"/TreeMatoGraph.ini") ((GetDir #plugcfg)+"/TreeMatoGraph.tmp")
				storeIniFile()
				copyfile ((GetDir #plugcfg)+"/TreeMatoGraph.ini") new_file
				deleteFile ((GetDir #plugcfg)+"/TreeMatoGraph.ini")
				copyfile ((GetDir #plugcfg)+"/TreeMatoGraph.tmp") ((GetDir #plugcfg)+"/TreeMatoGraph.ini") 
				deleteFile ((GetDir #plugcfg)+"/TreeMatoGraph.tmp")
			)
		)
		
		on load_preset pressed do
		(
			new_file = getOpenFileName filename:((GetDir #plugcfg)+"/*.tmg") types:"TreeMatoGraph Presets *.tmg |*.tmg"
			if new_file != undefined then
			(
				deleteFile ((GetDir #plugcfg)+"/TreeMatoGraph.ini")
				result = copyfile new_file ((GetDir #plugcfg)+"/TreeMatoGraph.ini")
				restoreIniFile()
				destroyDialog TreeMatoGraph_options_rollout
				if TreeMatoGraph_Currently_Edited_Tree != undefined then 
				(
					graph_bmp = bitmap graph_width graph_height color:background_color 
					background_plane = bitmap graph_width  graph_height color:background_color 
					back_plane = bitmap graph_width graph_height color:background_color 
					destroydialog TreeMatoGraph_rollout
					InitUtilityDialog()
					TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
					TreeMatoGraph_rollout.UiLog "Style Preset Loaded." 1
					TreeMatoGraph_rollout.displayNodeNames()
				)	
			)
		)	
		
		on cancel_options pressed do 
		(
			closeRolloutFloater TreeMatoGraph_options_floater
			restoreIniFile()
		)
		
		on close_options pressed do 
		(
			storeIniFile()
			closeRolloutFloater TreeMatoGraph_options_floater
			if TreeMatoGraph_Currently_Edited_Tree != undefined then 
			(
				graph_bmp = bitmap graph_width graph_height color:background_color 
				background_plane = bitmap graph_width  graph_height color:background_color 
				back_plane = bitmap graph_width graph_height color:background_color 
	
				destroydialog TreeMatoGraph_rollout
				InitUtilityDialog()
			    TreeMatoGraph_rollout.reloadMaterialTree()
			)	
		)

		on options_disableMissingMaps changed state do disableMissingMaps = state
		
		on options_ignore_dlx changed state do 
		(
			disable_UseAvguardExtension = state
			options_show_shaded.enabled = options_ghost.enabled = options_ghost_nth.enabled = state
		)	
		
		on options_right_click_behavior selected itm do right_click_behavior = itm
		on options_draw_node_shadows selected itm do draw_node_shadows = itm
		on options_shadow_density changed val do node_shadow_density = val
		
/*		
		on options_graph_width changed val do graph_width = val
		on options_graph_height changed val do graph_height = val
*/		
		on options_thumb_width changed val do thumb_width = val
		on options_thumb_height changed val do thumb_height = val
		on options_spacing_width changed val do thumb_hspacing = val
		on options_spacing_height changed val do thumb_vspacing = val
		on options_zoom_factor changed val do zoom_factor = val
		on options_zoom_quality changed val do zoom_quality = val

		on options_show_lines changed state do show_lines_while_moving = not state
		on options_show_shaded changed state do show_shaded_while_moving = state
		on options_ghost changed state do show_ghost_nodes = state
		on options_ghost_nth changed val do quickdraw_skip_lines = val
		on link_display selected itm do link_display_mode = itm
		on arrow_size changed value do link_arrow_size = value
		on root_sample selected itm do root_sample_object = itm
	
	)
	
	rollout TreeMatoGraph_options_color "Colors" rolledup:true
	(
		colorpicker options_background_color "Background" 					color:background_color align:#right			height:18	fieldwidth:40
		colorpicker options_parent_color 	"Link Color / Link At Parent" 	color:link_parent_color align:#right		height:18	fieldwidth:40
		
		checkbutton options_shaded_override "Override Shaded" 				across:2 align:#left checked:link_shaded_override height:18
		colorpicker options_child_color 	"Link At Child"  				color:link_child_color align:#right			height:18	fieldwidth:40

		colorpicker options_output_color 	"Output Highlight Color" 		color:link_output_color align:#right		height:18	fieldwidth:40
		colorpicker options_input_color 	"Input Highlight Color"  		color:link_input_color align:#right			height:18	fieldwidth:40
	
		colorpicker options_link_color 		"Linking Color" 				color:link_link_color align:#right			height:18	fieldwidth:40
		colorpicker options_unlink_color 	"Unlinking Color"  				color:link_unlink_color align:#right		height:18	fieldwidth:40
		
		colorpicker options_select_color 	"Selection Window Color"  		color:selection_window_color align:#right	height:18	fieldwidth:40
		

		on options_shaded_override changed state do link_shaded_override = state
		on options_background_color changed state do background_color = state
		on options_parent_color changed col do link_parent_color = col 
		on options_child_color changed col do link_child_color = col 
		on options_output_color changed col do link_output_color = col 
		on options_input_color changed col do link_input_color = col 
		on options_link_color changed col do link_link_color = col 
		on options_unlink_color changed col do link_unlink_color = col 
		on options_select_color changed col do selection_window_color = col 
	)
	
	
	fn ZoomRegion minx maxx miny maxy =
	(
	
			minx -= thumb_hspacing 
			miny -= thumb_vspacing 
			maxx += thumb_hspacing
			maxy += thumb_vspacing
			
			actual_start = ([minx,miny]/scale_factor)
			actual_end = ([maxx,maxy]/scale_factor)
			full_width = (maxx - minx)/scale_factor
			full_height = (maxy - miny)/scale_factor
			
			if full_width / full_height > graph_width/ graph_height then
				new_scale_factor = graph_width/scale_factor / full_width
			else	
				new_scale_factor = graph_height/scale_factor / full_height
			scale_factor = new_scale_factor
			if scale_factor > 9.99 then scale_factor = 9.99
			if scale_factor < 0.05 then scale_factor = 0.05
			origin_offset = [minx,miny]*scale_factor
			origin_offset.x = -origin_offset.x
			origin_offset.y = -origin_offset.y
			TreeMatoGraph_rollout.view_scale_factor.value = scale_factor *100.0
			TreeMatoGraph_rollout.view_scale_update()	
			TreeMatoGraph_rollout.UiLog ("Zoom to "+ TreeMatoGraph_rollout.view_scale_factor.value as string+ "%") 2 			
	)	

rollout TreeMatoGraph_about_rollout "About TreeMatoGraph"
(
	label about02 "TreeMatoGraph"
	label about04 "v.0.4.8 - 11/30/2002"
	label about08 "Copyright (c) 2002 by Borislav Petrov"
	hyperlink email_hyperlink "bobo@email.archlab.tuwien.ac.at" address:"mailto:bobo@email.archlab.tuwien.ac.at" align:#center
	label about12 " "
	button close_about "Close" align:#center
	
	on close_about pressed do destroyDialog TreeMatoGraph_about_rollout
)

local TMG_RCMenu

RcMenu TMG_RCMenu
(
	subMenu "Tree"
	(
		menuItem tmg_new "New Tree..."
		menuItem tmg_clear "Clear Tree..."
		separator tmp_mat_sep1
		menuItem tmg_pick_selected "Get From Selected Object"
		menuItem tmg_pick_scene "Pick From Scene"
		menuItem tmg_pick_name  "Pick By Name"
		menuItem tmg_pick_medit "Get Current Material Editor Slot"
		separator tmp_mat_sep2
		menuItem tmg_update_current "Reload Current Tree"
		menuItem tmg_update_thumbs "Update Thumbnails"
		separator tmp_mat_sep3
		menuItem tmg_put_selection "Assign To Selection"
		menuItem tmg_put_medit "Assign To Current Material Editor Slot"
	)

	subMenu "Edit"
	(
--		menuItem tmg_undo "Undo"
--		menuItem tmg_redo "Redo"
--		separator tmp_edit_sep1
		menuItem tmg_new_mat "Add New Material Node"
		menuItem tmg_new_map "Add New Map Node"
		separator tmp_edit_sep2
		menuItem tmg_options "Options..."
	)

	subMenu "Zoom"
	(
		menuItem tmg_zoom_all 		"Zoom All"
		menuItem tmg_zoom_selected 	"Zoom Selected"
		menuItem tmg_zoom_reset 	"Reset Pan And Zoom"
	)	
	
	subMenu "Display"
	(
		menuItem tmg_auto_arrange_down "Compact Top-To-Bottom"
		menuItem tmg_auto_arrange_right "Compact Left-To-Right"
		separator tmg_display_sep1	
		menuItem tmg_display_showmap  "Show Material In Viewport"
		menuItem tmg_display_hidemap  "Hide Material In Viewport"
		separator tmg_display_sep2
		menuItem tmg_display_disableall "Disable All Thumbnails"
		menuItem tmg_display_enableall	"Enable/Update All Thumbnails"
		separator tmg_display_sep3	
		
		menuItem tmg_display_lowq		"Quick And Dirty Thumbnails"
		menuItem tmg_display_goodq		"Good And Fast Thumbnails"
		menuItem tmg_display_midq		"Better And Slower Thumbnails"
		menuItem tmg_display_highq		"Best And Slow Thumbnails"
	)

	subMenu "Help"
	(
		menuItem tmg_help "TreeMatoGraph Webpage"
		separator tmg_help_sep1				
		menuItem tmg_boboland "More MAXScripts from Boboland"
		menuItem tmg_scriptspot "More MAXScripts from ScriptSpot"
		separator tmg_help_sep2		
		menuItem tmg_about "About TreeMatoGraph"
	)

	on tmg_zoom_selected picked do TreeMatoGraph_rollout.ZoomSelected ()
	
	on tmg_zoom_all picked do TreeMatoGraph_rollout.ZoomAll ()
	
	on tmg_zoom_reset picked do
	(
		scale_factor = 1.0
		origin_offset = [0.0,0.0]
		TreeMatoGraph_rollout.view_scale_factor.value = 100
		TreeMatoGraph_rollout.view_scale_update()
		TreeMatoGraph_rollout.UiLog ("Reset Pan And Zoom To Defaults.") 2 			
	)
	
	on tmg_display_lowq picked do
	(
		zoom_factor = 2.0
		zoom_quality = 0.1		
		TreeMatoGraph_PropertyChanged = timestamp()
	)
	
	on tmg_display_goodq picked do
	(
		zoom_factor = 2.0
		zoom_quality = 0.25
		TreeMatoGraph_PropertyChanged = timestamp()
	)	
	
	on tmg_display_midq picked do
	(
		zoom_factor = 2.0
		zoom_quality = 0.5
		TreeMatoGraph_PropertyChanged = timestamp()		
	)

	on tmg_display_highq picked do
	(
		zoom_factor = 2.0
		zoom_quality = 1.0
		TreeMatoGraph_PropertyChanged = timestamp()		
	)
	
	on tmg_display_disableall picked do 
	(
		for n in TreeMatoGraph_Nodes do
		(
			n.Renderable = false
			TreeMatoGraph_rollout.storeAppDataRenderable n
			if superclassof n.MaxNode == Material then
				map_bmp = TreeMatoGraph_rollout.TMG_renderMaterial n.MaxNode 1 1
			else
				map_bmp = renderMap n.MaxNode scale:100.0 size:[1, 1] filter:true
			map_sample = bitmap  n.Width n.Height color:((getPixels map_bmp [0,0] 1)[1])
			n.Thumbnail = map_sample
		)
		TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1	
		TreeMatoGraph_rollout.displayNodeNames()		
	)
	
	on tmg_display_enableall picked do 
	(
		for n in TreeMatoGraph_Nodes do	
		(
			n.Renderable = true
			TreeMatoGraph_rollout.storeAppDataRenderable n			
		)	
		TreeMatoGraph_PropertyChanged = timestamp()		
	)
	
	on tmg_undo picked do
	(
		RestoreUndoBuffer()
	)	
	
	on tmg_new_map picked do
	(
		if TreeMatoGraph_Currently_Edited_Tree == undefined then
		(
			TreeMatoGraph_rollout.UiLog "Cannot Create Map - Tree Root Missing!" 4		
		)
		else
		(
			TreeMatoGraph_rollout.getNewMapNode [graph_width/2, graph_height/2]
			TreeMatoGraph_rollout.storeTreePosition()
			TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1	
			TreeMatoGraph_rollout.displayNodeNames()
		)
	)
	
	on tmg_new_mat picked do
	(
		if TreeMatoGraph_Currently_Edited_Tree == undefined then
		(
			mat = copy (materialBrowseDlg #mats)
			if mat != undefined then
			(
				TreeMatoGraph_rollout.CreateNewRoot mat 			
			)
			else
			(
				TreeMatoGraph_rollout.UiLog "Material Tree Root Creation Failed!" 4		
			)
		)
		else
		(
			TreeMatoGraph_rollout.getNewMatNode [graph_width/2, graph_height/2]
			TreeMatoGraph_rollout.storeTreePosition()
			TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1	
			TreeMatoGraph_rollout.displayNodeNames()
		)	
	)
	
	on tmg_options picked do
	(
		try(closerolloutfloater TreeMatoGraph_options_floater)catch()
		TreeMatoGraph_options_floater = newRolloutFloater "TreeMatoGraph Options" 260 470
		addRollout TreeMatoGraph_options_rollout TreeMatoGraph_options_floater
		addRollout TreeMatoGraph_options_color TreeMatoGraph_options_floater
	)	

	on tmg_help picked do
	(
		shellLaunch "http://www.scriptspot.com/bobo/darkmoon/tmg/index.html" ""
	)	
	
	on tmg_update_thumbs picked do
	(
		TreeMatoGraph_PropertyChanged = timestamp()
	)

	on tmg_boboland picked do
	(
		shellLaunch "http://www.scriptspot.com/bobo/" ""
	)		

	on tmg_scriptspot picked do
	(
		shellLaunch "http://www.scriptspot.com/" ""
	)		
	
	on tmg_about picked do
	(
		CreateDialog TreeMatoGraph_about_rollout 200 130 modal:true
	)
	
	fn filter_mats obj = obj.material != undefined	
	on tmg_pick_scene picked do
	(
		obj = pickobject filter:filter_mats
		if obj != undefined then
		(
			TreeMatoGraph_rollout.buildTree obj.material
			TreeMatoGraph_rollout.restoreTreePosition()
			TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
			TreeMatoGraph_rollout.UiLog ("Loaded Material From ["+ obj.name +"]") 2
		)
		else
		(
			TreeMatoGraph_rollout.UiLog "Nothing Selected." 4
		)
	)	
	
	on tmg_display_showmap picked do 
	(
		TreeMatoGraph_rollout.SMIV true
	)	
	on tmg_display_hidemap picked do 
	(
		TreeMatoGraph_rollout.SMIV false
	)	
	
	on tmg_pick_selected picked do
	(
		if selection.count == 1 then
		(
			If selection[1].material != undefined then 
			(
				TreeMatoGraph_rollout.buildTree selection[1].material
				TreeMatoGraph_rollout.restoreTreePosition()
				TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
				TreeMatoGraph_rollout.UiLog ("Loaded Material From ["+ selection[1].name +"]") 2
			)
			else
			(
				TreeMatoGraph_rollout.UiLog ("Object ["+ selection[1].name +"] Has No Material.") 4
			)		
		)
		else
		(
			TreeMatoGraph_rollout.UiLog ("Too Many Objects Selected.") 4
		)	
	)	

	on tmg_pick_name picked do
	(
		obj = selectByName single:true filter:filter_mats title:"TMG: Pick Object to Acquire Material..."
		if obj != undefined then
		(
			TreeMatoGraph_rollout.buildTree obj.material
			TreeMatoGraph_rollout.restoreTreePosition()				
			TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
			TreeMatoGraph_rollout.UiLog ("Loaded Material From ["+ obj.name +"]") 2
			TreeMatoGraph_rollout.displayNodeNames()
		)
		else
		(
			TreeMatoGraph_rollout.UiLog "Nothing Selected." 4
		)		
	)	
	
	on tmg_update_current picked do
	(
		if TreeMatoGraph_Currently_Edited_Tree != undefined then 
		(
		    TreeMatoGraph_rollout.reloadMaterialTree()
		)	
	)
	
	on tmg_auto_arrange_down picked do
	(
		if TreeMatoGraph_Currently_Edited_Tree != undefined then 
		(
			view_order = 1
			store_old_positions()
			TreeMatoGraph_rollout.buildTree TreeMatoGraph_Currently_Edited_Tree 
			restore_old_lonely_positions()
			TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
			TreeMatoGraph_rollout.UiLog "Auto-Arranged Current Material Tree." 1
			TreeMatoGraph_rollout.displayNodeNames()
		)	
	)
	
	on tmg_auto_arrange_right picked do
	(
		if TreeMatoGraph_Currently_Edited_Tree != undefined then 
		(
			view_order = 2
			store_old_positions()
			TreeMatoGraph_rollout.buildTree TreeMatoGraph_Currently_Edited_Tree 
			restore_old_lonely_positions()
			TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
			TreeMatoGraph_rollout.UiLog "Auto-Arranged Current Material Tree." 1
			TreeMatoGraph_rollout.displayNodeNames()
		)	
	)
	
	on tmg_pick_medit picked do
	(
		get_mat = getMeditMaterial (medit.getActiveMtlSlot())
		if superclassof get_mat == material then
		(
			CreateUndoBuffer()
			TreeMatoGraph_Currently_Edited_Tree = get_mat
			TreeMatoGraph_rollout.buildTree TreeMatoGraph_Currently_Edited_Tree 
			TreeMatoGraph_rollout.restoreTreePosition()			
			TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
			TreeMatoGraph_rollout.UiLog ("Loaded Material ["+ TreeMatoGraph_Currently_Edited_Tree.name +"] From MEdit Slot "+ medit.getActiveMtlSlot() as string) 2
			TreeMatoGraph_rollout.displayNodeNames()
		)	
		else
		(
			TreeMatoGraph_rollout.UiLog "Cannot Get Bitmap as Root." 4
		)
	)
	
	on tmg_clear picked do
	(
		if TreeMatoGraph_Currently_Edited_Tree == undefined then 
			q = true
		else
			q = querybox "About to CLEAR the TreeMatoGraph Tree?\nThis will remove all nodes.\nTo secure the current tree,\nASSIGN to an Object or Material Editor Slot!" title:"CLEAR TreeMatoGraph?"
		if q then
		(
			copy graph_bmp back_plane
			TreeMatoGraph_rollout.graph_bitmap.bitmap = back_plane
			TreeMatoGraph_Nodes = #()
			TreeMatoGraph_Links = #()	
			TreeMatoGraph_rollout.displayNodeNames()	
			CreateUndoBuffer()
			TreeMatoGraph_Currently_Edited_Tree = undefined
			TreeMatoGraph_rollout.UiLog "TreeMatoGraph Cleared." 1
		)
		else
		(
			TreeMatoGraph_rollout.UiLog "TreeMatoGraph Clear Operation Canceled!" 4
		)
	)--end clear

	on tmg_new picked do
	(
		if TreeMatoGraph_Currently_Edited_Tree == undefined then 
			q = true
		else
			q = querybox "About to CREATE NEW TREE?\nThis will remove all current nodes.\nTo secure the current tree,\nASSIGN to an Object or Material Editor Slot!" title:"NEW TreeMatoGraph TREE?"
		if q then
		(
			mat = copy (materialBrowseDlg #mats)
			if mat != undefined then
			(
				TreeMatoGraph_rollout.CreateNewRoot mat 			
			)
			else
			(
				TreeMatoGraph_rollout.UiLog "Material Tree Root Creation Failed!" 4		
			)
		)
		else
		(
				TreeMatoGraph_rollout.UiLog "Material Tree Root Creation Canceled!" 4		
		)
	)--end new
	
	on tmg_put_selection picked do
	(
		selection.material = TreeMatoGraph_Currently_Edited_Tree
		TreeMatoGraph_rollout.UiLog ("Assigned To "+ selection.count as string+ " Selected Object(s)") 2
	)

	on tmg_put_medit picked do
	(
		medit_slot = medit.getActiveMtlSlot()
		setMeditMaterial medit_slot	TreeMatoGraph_Currently_Edited_Tree
		TreeMatoGraph_rollout.UiLog ("Assigned To MEdit Slot "+medit_slot as string) 2
	)
)--end RCMenu	

------------------
-- Link Rollout --
------------------
local TreeMatoGraph_link_map_rollout
local TreeMatoGraph_unlink_map_rollout


rollout TreeMatoGraph_link_map_rollout "TMG Link:"
(
	button link_child  "Link Child" width:90 across:2 align:#left
	checkbutton as_copy "As Copy" checked:false width:80 align:#right highlightcolor:(color 200 200 255)

	edittext label_source  ""
	label label_target0 "To Parent"
	edittext label_target  ""
	multilistbox map_list height:20
	
	fn link_function itm =
	(
		CreateUndoBuffer()
--		store_old_positions()
		local original_map = undefined
		if target_slots[itm][3] == "Material" and superclassof TMG_source_map != Material then 
		(
				TreeMatoGraph_rollout.UiLog ("Cannot Link: Material Expected.") 4
				return false
		)
		else
		(
			if target_slots[itm][3] == "Map" and superclassof TMG_source_map != TextureMap then 
			(
				TreeMatoGraph_rollout.UiLog ("Cannot Link: Map Exprected.") 4
			)
			else
			(
				if target_slots[itm][2] == "Property" then 
				(
					original_map = getProperty TMG_target_map target_slots[itm][1]
					if superclassof original_map == TextureMap or superclassof original_map == Material then
					(
						for i in TreeMatoGraph_Nodes do
						(
							if i.MaxNode == original_map and findItem lonely_nodes i == 0 then
							(
								append lonely_nodes i
							)	
						)	
					)
				if as_copy.checked then 	
					setProperty TMG_target_map target_slots[itm][1] (copy TMG_source_map)
				else	
					setProperty TMG_target_map target_slots[itm][1] TMG_source_map
				)
				else	
				(
					try(original_map = execute ("TMG_target_map"+target_slots[itm][2]+".object"))catch()
					if superclassof original_map == TextureMap or superclassof original_map == Material then
					(
						for i in TreeMatoGraph_Nodes do
						(
							if i.MaxNode == original_map and findItem lonely_nodes i == 0 then
							(
								append lonely_nodes i
							)	
						)	
					)
					txt = "TMG_target_map"+target_slots[itm][2]+ "= TMG_source_map\n"
					try(execute ( txt ))catch()
				)
			)
		)	
		true	
	)
	
	fn updateTreeAfterLink success=
	(
		local selected_channels = (map_list.selection as array).count
		destroyDialog TreeMatoGraph_link_map_rollout
		if success then
		(
			TreeMatoGraph_rollout.buildTree TreeMatoGraph_Currently_Edited_Tree
			restore_old_positions()		
			TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1	
			TreeMatoGraph_rollout.displayNodeNames()
			if selected_channels  == 1 then
			(
				for i in map_list.selection do
					TreeMatoGraph_rollout.UiLog ("Linked "+ map_list.items[i] +": " +TMG_source_map.name + " to " +TMG_target_map.name ) 2		
			)
			else	
			(
				TreeMatoGraph_rollout.UiLog ("Linked "+ selected_channels as string +" Channels: " +TMG_source_map.name + " to " +TMG_target_map.name ) 2		
			)
		)	
	)
	
	on map_list doubleclicked itm do 
	(
		store_old_positions()	
		success = link_function itm
		updateTreeAfterLink success
	)	
	on link_child pressed do 
	(
		store_old_positions()	
		success_counter = 0
		for i in map_list.selection do
		(
			success = link_function i
			if success then success_counter += 1
		)	
		updateTreeAfterLink (success_counter > 0)
	)
)

--------------------
-- Unlink Rollout --
--------------------

rollout TreeMatoGraph_unlink_map_rollout "TMG Unlink:"
(
	button unlink_child  "Unlink Child" width:180
	edittext label_source  ""
	label label_target0 "From Parent"
	edittext label_target  ""
	multilistbox map_list height:20
	
	fn unlink_function itm =
	(
		CreateUndoBuffer()

		store_old_positions()
		local original_map = undefined
		if linked_slots[itm][2] == "Property" then 
		(
			original_map = getProperty TMG_target_map linked_slots[itm][1]
			if superclassof original_map == TextureMap or superclassof original_map == Material then
			(
				for i in TreeMatoGraph_Nodes do
				(
					if i.MaxNode == original_map and findItem lonely_nodes i == 0 then
					(
						append lonely_nodes i
					)	
				)	
			)
			try (setProperty TMG_target_map linked_slots[itm][1] undefined)catch()
		)
		else	
		(
			try(original_map = execute ("TMG_target_map"+linked_slots[itm][2]+".object"))catch(original_map = undefined)
			if original_map == undefined then
				try(original_map = execute ("TMG_target_map"+linked_slots[itm][2]))catch(original_map = undefined)
			if superclassof original_map == TextureMap or superclassof original_map == Material then
			(
				for i in TreeMatoGraph_Nodes do
				(
					if i.MaxNode == original_map and findItem lonely_nodes i == 0 then
					(
						append lonely_nodes i
					)	
				)	
			)
			txt = "TMG_target_map"+linked_slots[itm][2]+ "= undefined\n"
			try(execute ( txt ))catch()
		)
	)
	
	fn updateTreeAfterUnlink =
	(
		local selected_channels = (map_list.selection as array).count
		destroyDialog TreeMatoGraph_unlink_map_rollout
		TreeMatoGraph_rollout.buildTree TreeMatoGraph_Currently_Edited_Tree
		restore_old_positions()		
		TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1	
		TreeMatoGraph_rollout.displayNodeNames()
		if selected_channels  == 1 then
		(
			for i in map_list.selection do
				TreeMatoGraph_rollout.UiLog ("Unlinked "+ map_list.items[i] +": " +TMG_source_map.name + " from " +TMG_target_map.name ) 2		
		)
		else	
		(
			TreeMatoGraph_rollout.UiLog ("Unlinked "+ selected_channels as string +" Channels: " +TMG_source_map.name + " from " +TMG_target_map.name ) 2		
		)
	)
	
	on map_list doubleclicked itm do 
	(
		unlink_function itm 
		updateTreeAfterUnlink()
	)	
	on unlink_child pressed do 
	(
		for i in map_list.selection do unlink_function i
		updateTreeAfterUnlink()
	)	
)

rollout TreeMatoGraph_console "TreeMatoGraph Console"
(
	listbox tmg_history items:UiLog_history selection:UiLog_history.count width:400 height:14 pos:[2,2]
)

------------------
-- Main Rollout --
------------------

local col_array = #()
rollout TreeMatoGraph_rollout  "TreeMatoGraph v0.4.8"
(
	bitmap graph_bitmap bitmap:graph_bmp width:graph_width height:graph_height pos:[0,0]
	checkbutton status_bar1 "" checked:true align:#left pos:[1000,1000] width:310 highlightcolor:(color 200 200 255) 
	checkbutton status_bar2 "" checked:true align:#left pos:[1000,1000] width:310 highlightcolor:(color 200 255 200) 
	checkbutton status_bar4 "" checked:true align:#left pos:[1000,1000] width:310 highlightcolor:(color 255 200 200) 
	checkbutton status_bar6 "" checked:true align:#left pos:[1000,1000] width:310 highlightcolor:(color 255 255 200) 
	
	fn defineColArray =
	(
		col_array = #( status_bar1, status_bar2, status_bar2, status_bar4, status_bar4, status_bar6 )
	)
	
	fn open_tmg_console =
	(
		try
		(
			destroyDialog TreeMatoGraph_console
			tmg_pos = getDialogPos TreeMatoGraph_rollout
			createDialog TreeMatoGraph_console 400 200 (tmg_pos.x+238) (tmg_pos.y+graph_height+85) style:#(#style_titlebar,#style_sysmenu)
		)
		catch()	
	)
	
	fn UiLog txt col_index =
	(
		for i = 1 to col_array.count where i != col_index do 
		(
			col_array[i].pos = [1000,1000]
		)	
		(col_array[col_index]).text = txt
		(col_array[col_index]).pos =[238,graph_height+22]
		append UiLog_history txt
		try
		(
			TreeMatoGraph_console.tmg_history.items = UiLog_history
			TreeMatoGraph_console.tmg_history.selection = UiLog_history.count
		)catch()	
	)	
	
	on status_bar1 changed state do 
	(
		status_bar1.checked = true
		open_tmg_console()
	)	
	on status_bar2 changed state do 
	(
		status_bar2.checked = true
		open_tmg_console()
	)	
	on status_bar4 changed state do 
	(
		status_bar4.checked = true
		open_tmg_console()
	)	
	on status_bar6 changed state do 
	(
		status_bar6.checked = true
		open_tmg_console()
	)	

	checkbutton move_mode "M" pos:[2,graph_height+1] width:20 height:20 checked:true highlightcolor:(color 255 255 200) tooltip:"Move / Select Multiple Nodes" images:#(tmg_move_icon, undefined, 2, 1, 2, 1, 2)
	checkbutton del_mode "D" pos:[2,graph_height+22] width:20 height:20 checked:false highlightcolor:(color 255 255 200) tooltip:"Delete Node - Unlinks from all parents and children and removes node" images:#(tmg_del_icon, undefined, 2, 1, 2, 1, 2)
	
	checkbutton link_mode "L" pos:[25,graph_height+1] width:20 height:20  checked:false highlightcolor:(color 255 255 200) tooltip:"Link Child Node to Parent Node's Channel(s)" images:#(tmg_link_icon, undefined, 2, 1, 2, 1, 2)
	checkbutton unlink_mode "U" pos:[25,graph_height+22] width:20 height:20  checked:false highlightcolor:(color 255 255 200) tooltip:"Unlink Child Node from Parent Node's Channel(s)" images:#(tmg_unlink_icon, undefined, 2, 1, 2, 1, 2)

	checkbutton auto_update "AUTO" pos:[48,graph_height+1] checked:auto_update_state width:53 height:20 highlightcolor:(color 200 255 200) tooltip:"Toggle Automatic Material Tree Updates"
	button rescan_tree "UPDATE" pos:[48,graph_height+22] width:53 height:20 tooltip:"Press to Reload the Current Material Tree"
	
	checkbutton show_node_names "Name" checked:show_node_names_state pos:[103,graph_height+1] width:35 height:20 highlightcolor:(color 200 200 255) tooltip:"Toggle Node Name Display"
	checkbutton show_node_class "Type" checked:show_node_class_state pos:[138,graph_height+1] width:35 height:20 highlightcolor:(color 200 200 255) tooltip:"Toggle Node Type (MAX Class) Display"
	checkbutton show_parent_channel "Out" checked:show_parent_channel_state  pos:[103,graph_height+22] width:35 height:20 highlightcolor:(link_output_color) tooltip:"Show Channels in Parents the Current Node is Linked to."
	checkbutton show_child_channel "In" checked:show_child_channel_state  pos:[138,graph_height+22] width:35 height:20 highlightcolor:(link_input_color) tooltip:"Show Channels that Children of the Current Node are Linked to."

	checkbutton pan_mode "P" pos:[174,graph_height+1] width:20 height:20  checked:false highlightcolor:(color 255 255 200) tooltip:"Pan Window - Alternatively, hold down Middle Mouse Button and drag mouse" images:#(tmg_pan_icon, undefined, 2, 1, 2, 1, 2)
	checkbutton zoom_mode "T" pos:[174,graph_height+22] width:20 height:20  checked:false highlightcolor:(color 255 255 200) tooltip:"Magnificy Thumbnail" images:#(tmg_mag_icon, undefined, 2, 1, 2, 1, 2)

	checkbutton zoomwin_mode "W" pos:[196,graph_height+1] width:20 height:20  checked:false highlightcolor:(color 255 255 200) tooltip:"Zoom Window" images:#(tmg_zoomwin_icon, undefined, 2, 1, 2, 1, 2)
	button zoomsel_button "S" pos:[217,graph_height+1] width:20 height:20  tooltip:"Zoom Selected" images:#(tmg_zoomsel_icon, undefined, 2, 1, 2, 1, 2)

	button zoomall_button "A" pos:[196,graph_height+22] width:20 height:20  tooltip:"Zoom All (Zoom Extents)" images:#(tmg_zoomall_icon, undefined, 2, 1, 2, 1, 2)
	button zoomreset_button "R" pos:[217,graph_height+22] width:20 height:20  tooltip:"Reset Pan And Zoom" images:#(tmg_zoomreset_icon, undefined, 2, 1, 2, 1, 2)

	spinner view_scale_factor pos:[237,graph_height+2] range:[5,999,scale_factor*100.0] fieldwidth:30  type:#integer
	button view_scale_50 ".5x" pos:[280,graph_height+1] width:20 height:18  tooltip:"Zoom Out to 50%"
	button view_scale_100 "1x" pos:[301,graph_height+1] width:20 height:18  tooltip:"Reset Zoom to 100%"
	button view_scale_200 "2x" pos:[322,graph_height+1] width:20 height:18  tooltip:"Zoom In to 200%"
	
	edittext map_edit_name width:178 pos:[340,graph_height+2]
	checkbutton quick_edit "qe" pos:[519,graph_height+2] checked:quickEditEnabled width:30 height:18 highlightcolor:(color 200 255 200) tooltip:"When checked, Node Double-Click opens QuickEdit, MaterialEditor when unchecked."
	
	on quick_edit changed state do 
	(
		quickEditEnabled = state
		storeIniFile()	
	)	
	
	on mat_button picked mat do
	(
		TreeMatoGraph_rollout.buildTree mat
		TreeMatoGraph_rollout.restoreTreePosition()
		TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
		TreeMatoGraph_rollout.UiLog ("New Material ["+ mat.name +"] Dropped.") 2
	)
	
	timer callback_update_clock interval:100.0 active:true
	
	on auto_update changed state do
	(
		if state then 
			registerMaterialPropertiesCallback ()
		else
			unregisterMaterialPropertiesCallback ()
		storeIniFile()	
	)
	
	on link_mode changed state do
	(
	    if state then
			move_mode.checked = del_mode.checked = unlink_mode.checked = pan_mode.checked = zoom_mode.checked = zoomwin_mode.checked = false
		else
			link_mode.checked = true
	)	
	on move_mode changed state do 
	(
	    if state then
			del_mode.checked = unlink_mode.checked = link_mode.checked = pan_mode.checked = zoom_mode.checked  = zoomwin_mode.checked = false
		else	
			move_mode.checked = true
	)	
	on del_mode changed state do 
	(
		if state then
			move_mode.checked = unlink_mode.checked = link_mode.checked = pan_mode.checked = zoom_mode.checked = zoomwin_mode.checked = false
		else	
			del_mode.checked = true
	)	
	on unlink_mode changed state do 
	(
		if state then
			move_mode.checked = del_mode.checked = link_mode.checked = pan_mode.checked = zoom_mode.checked = zoomwin_mode.checked = false
		else
			unlink_mode.checked = true
	)	

	on pan_mode changed state do 
	(
		if state then
			move_mode.checked = del_mode.checked = link_mode.checked = unlink_mode.checked = zoom_mode.checked = zoomwin_mode.checked = false
		else
			pan_mode.checked = true
	)	

	on zoom_mode changed state do 
	(
		if state then
			move_mode.checked = del_mode.checked = link_mode.checked = unlink_mode.checked = pan_mode.checked = zoomwin_mode.checked = false
		else
			zoom_mode.checked = true
	)	
	
	on zoomwin_mode changed state do 
	(
		if state then
			move_mode.checked = del_mode.checked = link_mode.checked = unlink_mode.checked = pan_mode.checked = zoom_mode.checked = false
		else
			zoomwin_mode.checked = true
	)		

	label thumb_label_01 "" pos:[1000,1000] align:#left
	label thumb_label_02 "" pos:[1000,1000] align:#left
	label thumb_label_03 "" pos:[1000,1000] align:#left
	label thumb_label_04 "" pos:[1000,1000] align:#left
	label thumb_label_05 "" pos:[1000,1000] align:#left
	label thumb_label_06 "" pos:[1000,1000] align:#left
	label thumb_label_07 "" pos:[1000,1000] align:#left
	label thumb_label_08 "" pos:[1000,1000] align:#left
	label thumb_label_09 "" pos:[1000,1000] align:#left
	label thumb_label_10 "" pos:[1000,1000] align:#left

	label thumb_label_11 "" pos:[1000,1000] align:#left
	label thumb_label_12 "" pos:[1000,1000] align:#left
	label thumb_label_13 "" pos:[1000,1000] align:#left
	label thumb_label_14 "" pos:[1000,1000] align:#left
	label thumb_label_15 "" pos:[1000,1000] align:#left
	label thumb_label_16 "" pos:[1000,1000] align:#left
	label thumb_label_17 "" pos:[1000,1000] align:#left
	label thumb_label_18 "" pos:[1000,1000] align:#left
	label thumb_label_19 "" pos:[1000,1000] align:#left
	label thumb_label_20 "" pos:[1000,1000] align:#left

	label thumb_label_21 "" pos:[1000,1000] align:#left
	label thumb_label_22 "" pos:[1000,1000] align:#left
	label thumb_label_23 "" pos:[1000,1000] align:#left
	label thumb_label_24 "" pos:[1000,1000] align:#left
	label thumb_label_25 "" pos:[1000,1000] align:#left
	label thumb_label_26 "" pos:[1000,1000] align:#left
	label thumb_label_27 "" pos:[1000,1000] align:#left
	label thumb_label_28 "" pos:[1000,1000] align:#left
	label thumb_label_29 "" pos:[1000,1000] align:#left
	label thumb_label_30 "" pos:[1000,1000] align:#left
	
	label thumb_label_31 "" pos:[1000,1000] align:#left
	label thumb_label_32 "" pos:[1000,1000] align:#left
	label thumb_label_33 "" pos:[1000,1000] align:#left
	label thumb_label_34 "" pos:[1000,1000] align:#left
	label thumb_label_35 "" pos:[1000,1000] align:#left
	label thumb_label_36 "" pos:[1000,1000] align:#left
	label thumb_label_37 "" pos:[1000,1000] align:#left
	label thumb_label_38 "" pos:[1000,1000] align:#left
	label thumb_label_39 "" pos:[1000,1000] align:#left
	label thumb_label_40 "" pos:[1000,1000] align:#left	

	label thumb_label_41 "" pos:[1000,1000] align:#left
	label thumb_label_42 "" pos:[1000,1000] align:#left
	label thumb_label_43 "" pos:[1000,1000] align:#left
	label thumb_label_44 "" pos:[1000,1000] align:#left
	label thumb_label_45 "" pos:[1000,1000] align:#left
	label thumb_label_46 "" pos:[1000,1000] align:#left
	label thumb_label_47 "" pos:[1000,1000] align:#left
	label thumb_label_48 "" pos:[1000,1000] align:#left
	label thumb_label_49 "" pos:[1000,1000] align:#left
	label thumb_label_50 "" pos:[1000,1000] align:#left	

	label thumb_label_51 "" pos:[1000,1000] align:#left
	label thumb_label_52 "" pos:[1000,1000] align:#left
	label thumb_label_53 "" pos:[1000,1000] align:#left
	label thumb_label_54 "" pos:[1000,1000] align:#left
	label thumb_label_55 "" pos:[1000,1000] align:#left
	label thumb_label_56 "" pos:[1000,1000] align:#left
	label thumb_label_57 "" pos:[1000,1000] align:#left
	label thumb_label_58 "" pos:[1000,1000] align:#left
	label thumb_label_59 "" pos:[1000,1000] align:#left
	label thumb_label_60 "" pos:[1000,1000] align:#left	

	label thumb_label_61 "" pos:[1000,1000] align:#left
	label thumb_label_62 "" pos:[1000,1000] align:#left
	label thumb_label_63 "" pos:[1000,1000] align:#left
	label thumb_label_64 "" pos:[1000,1000] align:#left
	label thumb_label_65 "" pos:[1000,1000] align:#left
	label thumb_label_66 "" pos:[1000,1000] align:#left
	label thumb_label_67 "" pos:[1000,1000] align:#left
	label thumb_label_68 "" pos:[1000,1000] align:#left
	label thumb_label_69 "" pos:[1000,1000] align:#left
	label thumb_label_70 "" pos:[1000,1000] align:#left	

	fn DefineThumbLabel = 
	(
		Thumb_label = #(thumb_label_01, thumb_label_02, thumb_label_03, thumb_label_04, thumb_label_05, thumb_label_06, thumb_label_07, thumb_label_08, thumb_label_09, thumb_label_10,
						thumb_label_11, thumb_label_12, thumb_label_13, thumb_label_14, thumb_label_15, thumb_label_16, thumb_label_17, thumb_label_18, thumb_label_19, thumb_label_20,
						thumb_label_21, thumb_label_22, thumb_label_23, thumb_label_24, thumb_label_25, thumb_label_26, thumb_label_27, thumb_label_28, thumb_label_29, thumb_label_30,
						thumb_label_31, thumb_label_32, thumb_label_33, thumb_label_34, thumb_label_35, thumb_label_36, thumb_label_37, thumb_label_38, thumb_label_39, thumb_label_40,
						thumb_label_41, thumb_label_42, thumb_label_43, thumb_label_44, thumb_label_45, thumb_label_46, thumb_label_47, thumb_label_48, thumb_label_49, thumb_label_50,
						thumb_label_51, thumb_label_52, thumb_label_53, thumb_label_54, thumb_label_55, thumb_label_56, thumb_label_57, thumb_label_58, thumb_label_59, thumb_label_60,
						thumb_label_61, thumb_label_62, thumb_label_63, thumb_label_64, thumb_label_65, thumb_label_66, thumb_label_67, thumb_label_68, thumb_label_69, thumb_label_70 
		)
	)

	
	
	label type_label_01 "" pos:[1000,1000] align:#left
	label type_label_02 "" pos:[1000,1000] align:#left
	label type_label_03 "" pos:[1000,1000] align:#left
	label type_label_04 "" pos:[1000,1000] align:#left
	label type_label_05 "" pos:[1000,1000] align:#left
	label type_label_06 "" pos:[1000,1000] align:#left
	label type_label_07 "" pos:[1000,1000] align:#left
	label type_label_08 "" pos:[1000,1000] align:#left
	label type_label_09 "" pos:[1000,1000] align:#left
	label type_label_10 "" pos:[1000,1000] align:#left

	label type_label_11 "" pos:[1000,1000] align:#left
	label type_label_12 "" pos:[1000,1000] align:#left
	label type_label_13 "" pos:[1000,1000] align:#left
	label type_label_14 "" pos:[1000,1000] align:#left
	label type_label_15 "" pos:[1000,1000] align:#left
	label type_label_16 "" pos:[1000,1000] align:#left
	label type_label_17 "" pos:[1000,1000] align:#left
	label type_label_18 "" pos:[1000,1000] align:#left
	label type_label_19 "" pos:[1000,1000] align:#left
	label type_label_20 "" pos:[1000,1000] align:#left

	label type_label_21 "" pos:[1000,1000] align:#left
	label type_label_22 "" pos:[1000,1000] align:#left
	label type_label_23 "" pos:[1000,1000] align:#left
	label type_label_24 "" pos:[1000,1000] align:#left
	label type_label_25 "" pos:[1000,1000] align:#left
	label type_label_26 "" pos:[1000,1000] align:#left
	label type_label_27 "" pos:[1000,1000] align:#left
	label type_label_28 "" pos:[1000,1000] align:#left
	label type_label_29 "" pos:[1000,1000] align:#left
	label type_label_30 "" pos:[1000,1000] align:#left
	
	label type_label_31 "" pos:[1000,1000] align:#left
	label type_label_32 "" pos:[1000,1000] align:#left
	label type_label_33 "" pos:[1000,1000] align:#left
	label type_label_34 "" pos:[1000,1000] align:#left
	label type_label_35 "" pos:[1000,1000] align:#left
	label type_label_36 "" pos:[1000,1000] align:#left
	label type_label_37 "" pos:[1000,1000] align:#left
	label type_label_38 "" pos:[1000,1000] align:#left
	label type_label_39 "" pos:[1000,1000] align:#left
	label type_label_40 "" pos:[1000,1000] align:#left	

	fn DefineTypeLabel = 
	(
		Type_label = #(type_label_01, type_label_02, type_label_03, type_label_04, type_label_05, type_label_06, type_label_07, type_label_08, type_label_09, type_label_10,
						type_label_11, type_label_12, type_label_13, type_label_14, type_label_15, type_label_16, type_label_17, type_label_18, type_label_19, type_label_20,
						type_label_21, type_label_22, type_label_23, type_label_24, type_label_25, type_label_26, type_label_27, type_label_28, type_label_29, type_label_30,
						type_label_31, type_label_32, type_label_33, type_label_34, type_label_35, type_label_36, type_label_37, type_label_38, type_label_39, type_label_40
		)
	)
	
	
	fn displayNodeNames =
	(
		if TreeMatoGraph_Nodes.count <= Thumb_label.count then max_labels = TreeMatoGraph_Nodes.count else max_labels = Thumb_label.count
		for n = 1 to max_labels do
		(
			if TreeMatoGraph_Nodes[n].Visible then
			(
				OriginalWidth = TreeMatoGraph_Nodes[n].Width
				OriginalHeight = TreeMatoGraph_Nodes[n].Height
				x = TreeMatoGraph_Nodes[n].XPos*scale_factor+origin_offset.x +OriginalWidth/2-OriginalWidth*scale_factor/2
				y = TreeMatoGraph_Nodes[n].YPos*scale_factor+origin_offset.y-13+OriginalHeight/2-OriginalHeight*scale_factor/2
				
				if y < graph_height-12 then
				(
					Thumb_label[n].pos = [x,y]
					map_name = ""
					if show_node_names.checked then map_name += TreeMatoGraph_Nodes[n].MaxNode.name + " "
					if show_node_class.checked then map_name += "["+ (classof TreeMatoGraph_Nodes[n].MaxNode as string)+"]"
					Thumb_label[n].text = map_name
				)
				else
				(
					Thumb_label[n].pos = [1000,1000]
				)	
			)
			else
			(
					Thumb_label[n].pos = [1000,1000]
			)	
		)
		for n = TreeMatoGraph_Nodes.count+1 to Thumb_label.count do
		(
			Thumb_label[n].pos = [1000,1000]
		)
	)	
	
	fn clearNodeTypes = 
	(
		for n in Type_label do n.pos = [1000,1000]
	)

 	fn ZoomSelected =
	(
		local minx = 10^6
		local miny = 10^6
		local maxx = -(10^6)
		local maxy = -(10^6)
		local doTheZoom = false
		for n in TreeMatoGraph_Nodes do
		(
			if n.Selected then
			(
				if n.XPos < minx then minx = n.XPos
				if n.YPos < miny then miny = n.YPos
				if n.XPos+n.Width > maxx then maxx = n.XPos+n.Width
				if n.YPos+n.Height > maxy then maxy = n.YPos+n.Height
				doTheZoom = true
			)
		)--end loop
		
		if doTheZoom then
		(
			ZoomRegion minx maxx miny maxy
		)	
	)
	
	fn ZoomAll =
	(
		local minx = 10^6
		local miny = 10^6
		local maxx = -(10^6)
		local maxy = -(10^6)
		local doTheZoom = false
		for n in TreeMatoGraph_Nodes do
		(
			if n.XPos < minx then minx = n.XPos
			if n.YPos < miny then miny = n.YPos
			if n.XPos+n.Width > maxx then maxx = n.XPos+n.Width
			if n.YPos+n.Height > maxy then maxy = n.YPos+n.Height
			doTheZoom = true
		)--end loop
		
		if doTheZoom then
		(
			ZoomRegion minx maxx miny maxy
		)	
	)
	
	on zoomsel_button pressed do ZoomSelected ()
	on zoomall_button pressed do ZoomAll ()

	fn drawArrow b_plane pos direction size color1 =
	(
		pixel_array = #()
		case direction of
		(
			1: (
 				append pixel_array color1
				for i = 1 to size do
				(
					append pixel_array color1
					append pixel_array color1
					setPixels b_plane [pos.x-i,pos.y+i-size/2.0] pixel_array
				)
			)	
			2: (
				for i = 0 to size do
				(
					append pixel_array color1
					setPixels b_plane [pos.x-size+size/2.0,pos.y-size+i] pixel_array
					setPixels b_plane [pos.x-size+size/2.0,pos.y+size-i] pixel_array
				)
			)	
			3: (
				append pixel_array color1
				for i = 1 to size do
				(
					append pixel_array color1
					append pixel_array color1
					setPixels b_plane [pos.x-i,pos.y-i+size/2.0] pixel_array
				)
			)	
			4: (
				for i = 0 to size do
				(
					append pixel_array color1
					setPixels b_plane [pos.x+size-i-size/2.0,pos.y-size+i] pixel_array
					setPixels b_plane [pos.x+size-i-size/2.0,pos.y+size-i] pixel_array
				)
			)			
			
		)	
	b_plane	
	)	
	
	fn drawNode node_index b_plane full_draw zoom_scale =
	(
		original_map = TreeMatoGraph_Nodes[node_index].Thumbnail
		draw_image = original_map != undefined
		OriginalWidth = TreeMatoGraph_Nodes[node_index].Width*zoom_scale
		OriginalHeight = TreeMatoGraph_Nodes[node_index].Height*zoom_scale
		map_to_draw = bitmap (OriginalWidth*scale_factor) (OriginalHeight*scale_factor)
		if draw_node_shadows > 1 then 
			shadow_to_draw = bitmap map_to_draw.width map_to_draw.height color:(background_color*(100.0-node_shadow_density)/100.0)

		case draw_node_shadows of
		(
			2: shadow_depth = 5*scale_factor
			3: shadow_depth = 1+TreeMatoGraph_Nodes[node_index].Row*scale_factor
		)
			
		copy original_map map_to_draw 
		if show_shaded_while_moving and full_draw == 0 then draw_image = false
		if full_draw == 0 and show_ghost_nodes then quickdraw_bitmaps_skip_lines = quickdraw_skip_lines else quickdraw_bitmaps_skip_lines = 1
		if TreeMatoGraph_Nodes[node_index].Selected then quickdraw_bitmaps_skip_lines = 1.5
		if UseAvguardExtension and not TreeMatoGraph_Nodes[node_index].Selected then
		(
			DrawIt = true
			actual_origin_x = 0
			actual_origin_y = 0
			actual_target_x = TreeMatoGraph_Nodes[node_index].XPos*scale_factor+origin_offset.x+OriginalWidth/2-OriginalWidth*scale_factor/2
			actual_target_y = TreeMatoGraph_Nodes[node_index].YPos*scale_factor+origin_offset.y+OriginalHeight/2-OriginalHeight*scale_factor/2
			actual_width = map_to_draw.Width
			actual_height = map_to_draw.Height
			if actual_target_x < 0 then 
			(
				actual_width += actual_target_x
				actual_origin_x -= actual_target_x
				actual_target_x = 0
				if abs(actual_width) > actual_width then DrawIt = false
			)	
			if actual_target_y < 0 then 
			(
				actual_height += actual_target_y
				actual_origin_y -= actual_target_y
				actual_target_y = 0
				if abs(actual_height) > actual_height then DrawIt = false
			)	
			
			if actual_target_x >= graph_width-1 then DrawIt = false
			if actual_target_y >= graph_height-1 then DrawIt = false
			
			if actual_width < 0 then actual_width = 0
			
			if DrawIt then
			(
				try
				(
					if draw_node_shadows > 1 then 
						pasteBitmap shadow_to_draw b_plane (Box2 actual_origin_x actual_origin_y actual_width actual_height) [actual_target_x+shadow_depth, actual_target_y+shadow_depth]
					pasteBitmap map_to_draw b_plane (Box2 actual_origin_x actual_origin_y actual_width actual_height) [actual_target_x, actual_target_y]
				)catch()	
			)	
		)
		else
		(
			target_x = TreeMatoGraph_Nodes[node_index].XPos*scale_factor+origin_offset.x+OriginalWidth/2-OriginalWidth*scale_factor/2
			get_pixels_amount = map_to_draw.Width
			get_pixles_offset = 0
			if target_x < 1 and (abs target_x) < get_pixels_amount then 
			(
				get_pixles_offset = abs(target_x) 
				get_pixels_amount -= get_pixles_offset 
			)	
			if target_x+get_pixels_amount > graph_width then get_pixels_amount -= target_x+get_pixels_amount-graph_width
			if draw_node_shadows > 1 then
				shadow_array = getPixels shadow_to_draw [get_pixles_offset,0] get_pixels_amount 
			if draw_image then
			(
				for j = 1 to map_to_draw.height by quickdraw_bitmaps_skip_lines do
				(
					pixel_array = getPixels map_to_draw [get_pixles_offset,j-1] get_pixels_amount 
					if draw_node_shadows > 1 then
						setPixels b_plane [target_x+get_pixles_offset+shadow_depth, TreeMatoGraph_Nodes[node_index].YPos*scale_factor+j-1+origin_offset.y+shadow_depth+OriginalHeight/2-OriginalHeight*scale_factor/2] shadow_array
					setPixels b_plane [target_x+get_pixles_offset, TreeMatoGraph_Nodes[node_index].YPos*scale_factor+j-1+origin_offset.y+OriginalHeight/2-OriginalHeight*scale_factor/2] pixel_array
				)	
			)
			else
			(
				pixel_array = #()
				for i = 1 to get_pixels_amount do append pixel_array TreeMatoGraph_Nodes[node_index].ShadedColor
				for j = 1 to map_to_draw.Height by quickdraw_bitmaps_skip_lines do
				(
					if draw_node_shadows > 1 then
						setPixels b_plane [target_x+get_pixles_offset+shadow_depth, TreeMatoGraph_Nodes[node_index].YPos*scale_factor+j-1+origin_offset.y+shadow_depth] shadow_array
					setPixels b_plane [target_x+get_pixles_offset , TreeMatoGraph_Nodes[node_index].YPos*scale_factor+j-1+origin_offset.y] pixel_array
				)	
			)
			actual_target_x = TreeMatoGraph_Nodes[node_index].XPos*scale_factor+origin_offset.x+OriginalWidth/2-OriginalWidth*scale_factor/2
			actual_target_y = TreeMatoGraph_Nodes[node_index].YPos*scale_factor+origin_offset.y+OriginalHeight/2-OriginalHeight*scale_factor/2
		)
		if TreeMatoGraph_Nodes[node_index].Collapsed then
			b_plane = drawArrow b_plane [actual_target_x+5, actual_target_y+5] 1 5 (color 255 0 0)
			
	b_plane
	)
	
	fn drawBorder node color1 b_plane =
	(
		
		width = TreeMatoGraph_Nodes[node].Width*scale_factor
		height= TreeMatoGraph_Nodes[node].Height*scale_factor
		pos_x = TreeMatoGraph_Nodes[node].XPos*scale_factor+origin_offset.x-Width/2.0 + TreeMatoGraph_Nodes[node].Width / 2.0
		pos_y = TreeMatoGraph_Nodes[node].YPos*scale_factor+origin_offset.y-Height/2.0 + TreeMatoGraph_Nodes[node].Height / 2.0
		
		pixel_array = #()
		for i = 0 to width-1 do append pixel_array color1
		setpixels b_plane [pos_x, pos_y] pixel_array
		setpixels b_plane [pos_x, pos_y+height-1] pixel_array
		pixel_array = #(color1)
		for i = 1 to height-1 do
		(
			setpixels b_plane [pos_x, pos_y+i] pixel_array
			setpixels b_plane [pos_x+width-1, pos_y+i] pixel_array
		)
	b_plane
	)
	
	
	fn drawSelectionWindow b_plane from_pos to_pos =
	(
		pixel_array = #()
		if from_pos.x > to_pos.x then
		(
			upper_left_x = to_pos.x
			lower_right_x = from_pos.x
		)	
		else
		(
			upper_left_x = from_pos.x
			lower_right_x = to_pos.x
		)
		if from_pos.y > to_pos.y then
		(
			upper_left_y = to_pos.y
			lower_right_y = from_pos.y
		)	
		else
		(
			upper_left_y = from_pos.y
			lower_right_y = to_pos.y
		)	
		w_width = lower_right_x-upper_left_x
		w_height = lower_right_y-upper_left_y
		for i = 1 to w_width do append pixel_array selection_window_color
		setPixels b_plane [upper_left_x, upper_left_y] pixel_array 
		setPixels b_plane [upper_left_x, lower_right_y] pixel_array 
		pixel_array = #(selection_window_color)
		for i = 1 to w_height do
		(
			setPixels b_plane [upper_left_x, upper_left_y+i] pixel_array 
			setPixels b_plane [lower_right_x, upper_left_y+i] pixel_array 
		)
	b_plane 
	)
	
	fn drawConnection from_point to_point b_plane dash_step dash_length color1 color2 mode=
	(
		start_color = color1 
		end_color = color2   

		from_point.x += origin_offset.x + 1
		from_point.y += origin_offset.y + 1
		to_point.x += origin_offset.x - 1
		to_point.y += origin_offset.y - 1
		
		if from_point.x < 0 then from_point.x = 0
		if to_point.x < 0 then to_point.x = 0

		if from_point.x > graph_width then from_point.x = graph_width
		if to_point.x > graph_width then to_point.x = graph_width
		
		mid_point = (from_point + to_point)/2.0
		sub_point = (from_point - to_point)
		abs_sub_point = Point2 (abs sub_point.x) (abs sub_point.y)
		case mode of
		(
			1: horizontal_first = abs_sub_point.x > abs_sub_point.y 
			2: horizontal_first = true
			3: horizontal_first = false
		)	
		
		if horizontal_first then
		(
			pixel_array = #()
			for x = 0 to abs_sub_point.x/2.0 do
			(
				append pixel_array start_color
			)
			if sub_point.x < 0 then
			(
				setPixels b_plane [from_point.x,from_point.y] pixel_array
				setPixels b_plane [mid_point.x,to_point.y] pixel_array
				
			)
			else
			(
				setPixels b_plane [to_point.x,to_point.y] pixel_array
				setPixels b_plane [mid_point.x,from_point.y] pixel_array
			)	
			pixel_array = #(start_color)
			if sub_point.y < 0 then
			(
				for y =  1 to abs_sub_point.y do
					setPixels b_plane [mid_point.x,from_point.y+y] pixel_array
				if abs_sub_point.y < link_arrow_size then
				(
					if sub_point.x < 0 then
						drawArrow b_plane mid_point 4 link_arrow_size start_color
					else	
						drawArrow b_plane mid_point 2 link_arrow_size start_color
				)
				else	
					drawArrow b_plane mid_point 1 link_arrow_size start_color
			)	
			else
			(
				for y =  1 to abs_sub_point.y do
					setPixels b_plane [mid_point.x,from_point.y-y] pixel_array
				if abs_sub_point.y < link_arrow_size then
				(
					if sub_point.x < 0 then
						drawArrow b_plane mid_point 4 link_arrow_size start_color
					else	
						drawArrow b_plane mid_point 2 link_arrow_size start_color
				)		
				else	
					drawArrow b_plane mid_point 3 link_arrow_size start_color
			)
		)
		else
		(
			pixel_array = #()
			for x = 0 to abs_sub_point.x do
			(
				append pixel_array start_color
			)
			if sub_point.x < 0 then
			(
				setPixels b_plane [from_point.x,mid_point.y] pixel_array
				if abs_sub_point.x < link_arrow_size then
				(
					if sub_point.y < 0 then
						drawArrow b_plane mid_point 1 link_arrow_size start_color
					else	
						drawArrow b_plane mid_point 3 link_arrow_size start_color
				)		
				else	
					drawArrow b_plane mid_point 4 link_arrow_size start_color
			)
			else
			(
				setPixels b_plane [to_point.x,mid_point.y] pixel_array
				if abs_sub_point.x < link_arrow_size then
				(
					if sub_point.y < 0 then
						drawArrow b_plane mid_point 1 link_arrow_size start_color
					else	
						drawArrow b_plane mid_point 3 link_arrow_size start_color
				)	
				else	
					drawArrow b_plane mid_point 2 link_arrow_size start_color
			)	
			pixel_array = #(start_color)
			if sub_point.y < 0 then
			(
				for y = 0 to abs_sub_point.y/2.0 do
				(
					setPixels b_plane [from_point.x,from_point.y+y] pixel_array
					setPixels b_plane [to_point.x,to_point.y-y] pixel_array
				)	
				
			)	
			else
			(
				for y =  1 to abs_sub_point.y/2 do
				(
					setPixels b_plane [from_point.x,from_point.y-y] pixel_array
					setPixels b_plane [to_point.x,to_point.y+y] pixel_array
				)	
			)
		)	
	b_plane	
	)	
	
	fn drawDiagonalConnection from_point to_point b_plane dash_step dash_length color1 color2 =
	(
		start_color = color1 --link_parent_color
		
		if link_shaded_override then
			end_color = link_child_color
		else
			end_color = color2   
			
		dx = to_point.x - from_point.x
		dy = to_point.y - from_point.y
		if abs(dx) > abs(dy) then steps = abs(dx) else steps = abs(dy)
		linex = from_point.x+origin_offset.x
		liney = from_point.y+origin_offset.y
		stepdx = dx/ steps as float
		stepdy = dy/ steps as float
		color_delta = (end_color-start_color)/steps as float
		current_color = start_color
		dash_count = 0
		for i = 1 to steps do
		(
			linex += stepdx
			liney += stepdy
			current_color += color_delta
			pixel_array = #(current_color,current_color)
			dash_count += 1
			if dash_count <=dash_length then
				setPixels b_plane [linex,liney] pixel_array
			
			if dash_count == dash_step then
				dash_count = 0
		)
	b_plane	
	)

	fn drawMoveNodeLines b_plane except dash_step dash_length color1 color2=
	(
		for l in TreeMatoGraph_Links do
		(
			if l[1] > 0 and l[2] > 0 then
			(
				if TreeMatoGraph_Nodes[l[1]].Visible and TreeMatoGraph_Nodes[l[2]].Visible then
				(
					if findItem except l[1] > 0 or findItem except l[2] > 0 then	
					(
						from_middle_x = TreeMatoGraph_Nodes[l[1]].XPos*scale_factor+TreeMatoGraph_Nodes[l[1]].Width/2.0
						from_middle_y = TreeMatoGraph_Nodes[l[1]].YPos*scale_factor+TreeMatoGraph_Nodes[l[1]].Height/2.0
						to_middle_x = TreeMatoGraph_Nodes[l[2]].XPos*scale_factor+TreeMatoGraph_Nodes[l[2]].Width/2.0
						to_middle_y = TreeMatoGraph_Nodes[l[2]].YPos*scale_factor+TreeMatoGraph_Nodes[l[2]].Height/2.0
						case link_display_mode of
						(
							1: (
								if findItem except l[2] > 0 then 
									b_plane = drawDiagonalConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_output_color link_output_color
								else
									b_plane = drawDiagonalConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_input_color link_input_color
								)
							2: (
								if findItem except l[2] > 0 then 
									b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_output_color link_output_color 1
								else
									b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_input_color link_input_color 1
							)	
							3: (
								if findItem except l[2] > 0 then 
									b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_output_color link_output_color 2
								else
									b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_input_color link_input_color 2
							)	
							4: (
								if findItem except l[2] > 0 then 
									b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_output_color link_output_color 3
								else
									b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_input_color link_input_color 3
							)	
							
						)	
					)		
				)	
			)		
		)
	b_plane	
	)

	fn drawConnectNodeLine b_plane from_node to_pos dash_step dash_length color1 color2 =
	(
		from_middle_x = TreeMatoGraph_Nodes[from_node].XPos*scale_factor+TreeMatoGraph_Nodes[from_node].Width/2.0
		from_middle_y = TreeMatoGraph_Nodes[from_node].YPos*scale_factor+TreeMatoGraph_Nodes[from_node].Height/2.0
		case link_display_mode of
		(
			1: b_plane = drawDiagonalConnection (Point2 from_middle_x from_middle_y) to_pos b_plane dash_step dash_length color1 color2
			2: b_plane = drawConnection to_pos (Point2 from_middle_x from_middle_y)  b_plane dash_step dash_length color1 color2 1
			3: b_plane = drawConnection to_pos (Point2 from_middle_x from_middle_y)  b_plane dash_step dash_length color1 color2 2
			4: b_plane = drawConnection to_pos (Point2 from_middle_x from_middle_y)  b_plane dash_step dash_length color1 color2 3
		)			
	b_plane	
	)
	
	fn draw_origin b_plane=
	(	
		origin_pixels = #((color 255 0 0),(color 255 0 0),(color 255 0 0),(color 255 0 0),(color 255 0 0),(color 255 0 0),(color 255 0 0),(color 255 0 0),(color 255 0 0))
		setPixels b_plane [origin_offset.x-4,origin_offset.y] origin_pixels
		origin_pixels = #((color 255 0 0))
		for i = -4 to 4 do
		(
			setPixels b_plane [origin_offset.x,origin_offset.y+i] origin_pixels
		)
	b_plane	
	)

	fn drawAllNodes b_plane except dash_step dash_length full_draw=
	(
		if full_draw == 1 or show_lines_while_moving then
		(
		for l in TreeMatoGraph_Links do
		(
			if l[1] > 0 and l[2] > 0 then
			(
				if TreeMatoGraph_Nodes[l[1]].Visible and TreeMatoGraph_Nodes[l[2]].Visible then
				(
					if findItem except l[1] == 0 and findItem except l[2] == 0 then
					(
						from_middle_x = TreeMatoGraph_Nodes[l[1]].XPos*scale_factor+TreeMatoGraph_Nodes[l[1]].Width/2.0
						from_middle_y = TreeMatoGraph_Nodes[l[1]].YPos*scale_factor+TreeMatoGraph_Nodes[l[1]].Height/2.0
						to_middle_x = TreeMatoGraph_Nodes[l[2]].XPos*scale_factor+TreeMatoGraph_Nodes[l[2]].Width/2.0
						to_middle_y = TreeMatoGraph_Nodes[l[2]].YPos*scale_factor+TreeMatoGraph_Nodes[l[2]].Height/2.0
					
						if current_node == l[1] or current_node == l[2] then
						(
							case link_display_mode of
							(
								1: b_plane = drawDiagonalConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_parent_color TreeMatoGraph_Nodes[l[1]].ShadedColor
								2: b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_parent_color link_child_color 1
								3: b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_parent_color link_child_color 2
								4: b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane dash_step dash_length link_parent_color link_child_color 3
							)
						)
						else	
						(
							case link_display_mode of
							(
								1: (
									if link_shaded_override then
										link_color = link_child_color 
									else
										link_color = TreeMatoGraph_Nodes[l[2]].ShadedColor
									b_plane = drawDIagonalConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane 1 1 link_parent_color link_color
									)
								2: (
									if link_shaded_override then
										link_color = link_parent_color 
									else
										link_color = TreeMatoGraph_Nodes[l[2]].ShadedColor
									b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane 1 1 link_color link_child_color 1
									)	
								3: (
									if link_shaded_override then
										link_color = link_parent_color 
									else
										link_color = TreeMatoGraph_Nodes[l[2]].ShadedColor
									b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane 1 1 link_color link_child_color 2
									)
								4: (
									if link_shaded_override then
										link_color = link_parent_color 
									else
										link_color = TreeMatoGraph_Nodes[l[2]].ShadedColor
									b_plane = drawConnection (Point2 from_middle_x from_middle_y) (Point2 to_middle_x to_middle_y) b_plane 1 1 link_color link_child_color 3
									)
							)	
						)	
					)	
				)	
			)		
		)
		)
		for n = 1 to TreeMatoGraph_Nodes.count do
		(
			if findItem except n == 0 and TreeMatoGraph_Nodes[n].Visible then 
				b_plane = drawNode n b_plane full_draw 1.0
		)
		b_plane = draw_origin b_plane
	b_plane 
	)	
	
	fn NodeHitTest pos =
	(
		hit_node = 0
		for n = 1 to TreeMatoGraph_Nodes.count do
		(
			x_pos = TreeMatoGraph_Nodes[n].XPos*scale_factor+origin_offset.x +TreeMatoGraph_Nodes[n].Width/2.0-TreeMatoGraph_Nodes[n].Width*scale_factor/2.0
			y_pos = TreeMatoGraph_Nodes[n].YPos*scale_factor+origin_offset.y +TreeMatoGraph_Nodes[n].Height/2.0-TreeMatoGraph_Nodes[n].Height*scale_factor/2.0
			if pos.x >= x_pos and pos.y >= y_pos and pos.x <= x_pos+TreeMatoGraph_Nodes[n].Width*scale_factor and pos.y <= y_pos+TreeMatoGraph_Nodes[n].Height*scale_factor then
			(
				if TreeMatoGraph_Nodes[n].Visible then
				(
					hit_node = n
					exit
				)	
			)
		)	
	hit_node		
	)
	
	fn findClosestParent index=
	(
		parent_index = index
		go_on = true
		while go_on do
		(
			parent_index = collect_nodes[parent_index][3]
			try(check_class = superclassof collect_nodes[parent_index][1].object )catch(check_class = 0)
			if check_class == 0 then try(check_class = superclassof collect_nodes[parent_index][1])catch(check_class = 0)
			if check_class == Material or check_class == TextureMap then go_on = false
		)
	parent_index	
	)
	
	fn collecLightsState = 
	(
		lights_state = #()
		lights_array = for l in Lights where classof l != TargetObject collect l
		for l in lights_array do 
		(
			append lights_state l.on
			l.on = false
		)
	)
	
	fn restoreLightsState = 
	(
		for l = 1 to lights_array.count do 
		(
			lights_array[l].on = lights_state[l]
		)
	)
	
	fn storeAppData node_record =
	(
		app_data_start = 20020515
		setAppData node_record.MaxNode (app_data_start+1) (node_record.Xpos as string)
		setAppData node_record.MaxNode (app_data_start+2) (node_record.YPos as string)
	)

	fn restoreAppData node_record =
	(
		app_data_start = 20020515
		New_Pos = Point2 0.0 0.0
		try
		(
			new_x = Execute( getAppData node_record.MaxNode (app_data_start+1))
			new_y = Execute( getAppData node_record.MaxNode (app_data_start+2))
			if new_x != undefined then New_Pos.x = new_x
			if new_y != undefined then New_Pos.y = new_y
		)
		catch()
		New_pos
	)

	fn storeAppDataRenderable node_record =
	(
		app_data_start = 20020515
		setAppData node_record.MaxNode (app_data_start+3) (node_record.Renderable as string)
	)	
	
	
	fn restoreAppDataRenderable node_record =
	(
		app_data_start = 20020515
		try(Execute( getAppData node_record.MaxNode (app_data_start+3)))catch(true)
	)
	


	fn storeTreePosition =
	(
		for i in TreeMatoGraph_Nodes do
		(
			storeAppData i
		)
	)
	
	fn restoreTreePosition =
	(
		for i in TreeMatoGraph_Nodes do
		(
			read_record = restoreAppData i
			if read_record != [0.0,0.0] then 
			(
				i.XPos = read_record.x
				i.YPos = read_record.y
			)
		)
	)
	
	fn SMIV switch =
	(
		for i in TreeMatoGraph_Nodes do
		(
			if superclassof i.MaxNode == Material then showTextureMap i.MaxNode switch
		)
	)
	
	
	fn CreateNewRoot mat =
	(
		TreeMatoGraph_Nodes = #()
		TreeMatoGraph_Links = #()	
		CreateUndoBuffer()
		TreeMatoGraph_Currently_Edited_Tree = mat
		TreeMatoGraph_rollout.buildTree TreeMatoGraph_Currently_Edited_Tree 
		TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
		TreeMatoGraph_rollout.displayNodeNames()	
		TreeMatoGraph_rollout.UiLog ("Created New "+ (classof mat as string) +" Material ["+mat.name+"]") 2
	)
	
	-------------------------------------------------------------------------
	--Automatically Detect Map and Material Slots visible to ShowProperties--
	-------------------------------------------------------------------------
	fn DetectMapSlots mat collect_mode=
	(
		map_slots = #()
		strs = StringStream ""
		showProperties mat to:strs
		seek strs 0
		while not eof strs do
		(
			str = readLine strs 
			if collect_mode != 2 then
			(
				texmappos = findstring str ": texmap" 
				texmaparraypos = findstring str ": texmap array" 
				if texmappos != undefined and texmaparraypos == undefined then 
				(
					startpos = findstring str "." 
					str = substring str (startpos+1) 1000
					endpos = findstring str " " 
					str = substring str 1 (endpos-1)
					append map_slots #( execute ("#"+str)as name, "Property", "Map")
				)	
			)	
			if collect_mode != 1 then
			(
				matpos = findstring str ": material" 
				if matpos != undefined then 
				(
					startpos = findstring str "." 
					str = substring str (startpos+1) 1000
					endpos = findstring str " " 
					str = substring str 1 (endpos-1)
					append map_slots #( execute ("#"+str), "Property", "Material")
				)			
			)	
		)
		close strs
		map_slots 
	)	
	
	
	fn collectMapSlots map sourceClass =
	(
		if sourceClass == undefined then collect_mode = 0
		if sourceClass == TextureMap then collect_mode = 1
		if sourceClass == Material then collect_mode = 2
		
		props = getPropNames map
		map_slots = #()		
		if collect_mode < 2 then
		(
			case (classof map) of
			(
				Bricks: ( 
					append map_slots #("Bricks", ".bricks_map", "Map")
					append map_slots #("Mortar", ".mortar_map", "Map")
				)

				MAXShadeTextureMap: (
							for m = 1 to map.Texturemaps.numsubs do
							(
								local full_name = (map.Texturemaps[m] as string)
								full_name = substring full_name 9 1000
								if full_name != "" and findstring full_name "_Amount" == undefined  then
								(
									append map_slots #( full_name, ".Texturemaps."+ full_name , "Map")
								)	
							)	
						)
				
				SimbiontMAXtextureMap: (
					for m = 1 to map.dttm_tweak_maps.count do
					(
						if map.dttm_tweak_types[m] == 5 or map.dttm_tweak_types[m] == 6 then 
						(
							map.dtmax_maps_ens[m] = true
							append map_slots #( map.dttm_tweak_names[m], ".dttm_tweak_maps["+ m as string +"]" , "Map")
						)	
					)	
				)
				
				CompositeTexturemap: ( 
					for i = 1 to map.mapList.count do 
					(
						append map_slots #( ("Map "+i as string), ".mapList[" + i as string +"]", "Map" ) 
					)
				)	
				default: DetectMapSlots map collect_mode
				)--end case	
		)
		
			case (classof map) of
			(
			MAXShade: 		(
									if collect_mode != 2 then 
									(
										for m = 1 to map.maps.numsubs do
										(
											local full_name = (map.maps[m] as string)
											full_name = substring full_name 9 1000
											if full_name != "" and findstring full_name "_Amount" == undefined  then
											(
												append map_slots #( full_name, ".maps."+ full_name , "Map")
											)	
										)	
									)		
								)
			
			SimbiontMAX: 		(
									if collect_mode != 2 then 
									(
										for m = 1 to map.dtmax_maps_names.count do
										(
											if map.dtmax_maps_names[m] != "" then
											(
												map.dtmax_maps_ens[m] = true
												append map_slots #( map.dtmax_maps_names[m], ".dtmax_maps_texmap["+ m as string +"]" , "Map")
											)	
										)	
									)		
								)
			
			compositematerial:	(
									if collect_mode != 1 then 
									(
										map_slots = #(#(#baseMaterial, "Property", "Material"))
										for i = 2 to map.materialList.count do 
											append map_slots #( ("Mat "+(i-1) as string), ".materialList[" + i as string +"]", "Material" ) 
									)		
								)	
/*			Morphermaterial:	(
									map_slots = #(
									#(#base, "Property", "Material"))
									for i = 0 to 99 do 
										append map_slots #( ("Mat_"+i as string), ".mat_" + i as string , "Material" ) 
								)				
*/
			Multimaterial:		(
									if collect_mode != 1 then 
									(
										map_slots = #()
										for i = 1 to map.materialList.count do 
											append map_slots #( ("Mat "+i as string), ".materialList[" + i as string +"]", "Material" ) 
									)		
								)				
			RaytraceMaterial: 	(
									if collect_mode != 2 then 
									(
										for p in props do
											if findstring (p as string) "Map" == (p as string).count-2 then append map_slots #(p, "Property", "Map")
									)		
								)
			StandardMaterial:	(
									if collect_mode != 2 then 
									(
										case map.shadertype of
										(
										0:	(
											map_slots = #( 
												#(#AmbientMap, "Property", "Map"),
	 											#(#DiffuseMap, "Property", "Map"), 
												#(#SpecularMap, "Property", "Map"), 
												#(#DiffuseLevelMap, "Property", "Map"), 
												#(#SpecularLevelMap, "Property", "Map"), 
												#(#GlossinessMap,"Property", "Map"), 
												#(#AnisotropyMap, "Property", "Map"), 
												#(#OrientationMap, "Property", "Map"), 
												#(#SelfIllumMap, "Property", "Map"), 
												#(#OpacityMap, "Property", "Map"), 
												#(#FilterMap, "Property", "Map"), 
												#(#BumpMap, "Property", "Map"), 
												#(#ReflectionMap, "Property", "Map"), 
												#(#RefractionMap, "Property", "Map"), 
												#(#DisplacementMap, "Property", "Map") )
											)
										1:	(
											map_slots = #(
												#(#AmbientMap, "Property", "Map"), 
												#(#DiffuseMap, "Property", "Map"), 
												#(#SpecularMap, "Property", "Map"), 
												#(#SpecularLevelMap, "Property", "Map"), 
												#(#GlossinessMap,"Property", "Map"), 
												#(#SelfIllumMap, "Property", "Map"), 
												#(#OpacityMap, "Property", "Map"), 
												#(#FilterMap, "Property", "Map"), 
												#(#BumpMap, "Property", "Map"), 
												#(#ReflectionMap, "Property", "Map"), 
												#(#RefractionMap, "Property", "Map"), 
												#(#DisplacementMap, "Property", "Map") )
											)
										2:	(
											map_slots = #(
												#(#AmbientMap, "Property", "Map"), 
												#(#DiffuseMap, "Property", "Map"), 
												#(#SpecularMap, "Property", "Map"), 
												#(#SpecularLevelMap, "Property", "Map"), 
												#(#GlossinessMap,"Property", "Map"), 
												#(#SelfIllumMap, "Property", "Map"), 
												#(#OpacityMap, "Property", "Map"), 
												#(#FilterMap, "Property", "Map"), 
												#(#BumpMap, "Property", "Map"), 
												#(#ReflectionMap, "Property", "Map"), 
												#(#RefractionMap, "Property", "Map"), 
												#(#DisplacementMap, "Property", "Map") )
											)										
										3:	(
											map_slots = #(
												#(#AmbientMap, "Property", "Map"), 
												#(#DiffuseMap, "Property", "Map"), 
												#(#DiffuseLevelMap, "Property", "Map"), 
												#(#DiffuseRoughnessMap, "Property", "Map"), 
												#(#SpecularMap, "Property", "Map"), 
												#(#SpecularLevelMap, "Property", "Map"), 
												#(#GlossinessMap,"Property", "Map"), 
												#(#AnisotropyMap, "Property", "Map"), 
												#(#OrientationMap, "Property", "Map"), 
												#(#SpecularMap2, "Property", "Map"), 
												#(#SpecularLevelMap2, "Property", "Map"), 
												#(#GlossinessMap2, "Property", "Map"), 
												#(#AnisotropyMap2, "Property", "Map"), 
												#(#OrientationMap2, "Property", "Map"), 
												#(#SelfIllumMap, "Property", "Map"), 
												#(#OpacityMap, "Property", "Map"), 
												#(#FilterMap, "Property", "Map"), 
												#(#BumpMap, "Property", "Map"), 
												#(#ReflectionMap, "Property", "Map"), 
												#(#RefractionMap, "Property", "Map"), 
												#(#DisplacementMap, "Property", "Map") )
											)
										4:	(
											map_slots = #(
												#(#AmbientMap, "Property", "Map"), 
												#(#DiffuseMap, "Property", "Map"), 
												#(#SpecularMap, "Property", "Map"), 
												#(#GlossinessMap, "Property", "Map"), 
												#(#SpecularLevelMap, "Property", "Map"), 
												#(#SelfIllumMap, "Property", "Map"), 
												#(#OpacityMap, "Property", "Map"), 
												#(#FilterMap, "Property", "Map"), 
												#(#DiffuseLevelMap, "Property", "Map"), 
												#(#DiffuseRoughnessMap, "Property", "Map"), 
												#(#BumpMap, "Property", "Map"), 
												#(#ReflectionMap, "Property", "Map"), 
												#(#RefractionMap, "Property", "Map"), 
												#(#DisplacementMap, "Property", "Map") )
											)
										5:	(
											map_slots = #(
												#(#AmbientMap, "Property", "Map"), 
												#(#DiffuseMap, "Property", "Map"), 
												#(#SpecularMap, "Property", "Map"), 
												#(#SpecularLevelMap, "Property", "Map"), 
												#(#GlossinessMap, "Property", "Map"), 
												#(#SelfIllumMap, "Property", "Map"), 
												#(#OpacityMap, "Property", "Map"), 
												#(#FilterMap, "Property", "Map"), 
												#(#BumpMap, "Property", "Map"), 
												#(#ReflectionMap, "Property", "Map"), 
												#(#RefractionMap, "Property", "Map"), 
												#(#DisplacementMap, "Property", "Map") )
											)										
										6:	(
											map_slots = #(
												#(#DiffuseMap,"Property", "Map"), 
												#(#GlossinessMap, "Property", "Map"), 
												#(#MetalnessMap, "Property", "Map"), 
												#(#OpacityMap, "Property", "Map"), 
												#(#FilterMap, "Property", "Map"), 
												#(#BumpMap, "Property", "Map"), 
												#(#ReflectionMap, "Property", "Map"), 
												#(#RefractionMap, "Property", "Map"), 
												#(#DisplacementMap, "Property", "Map") )
											)										
										7:	(
											map_slots = #(
												#(#AmbientMap, "Property", "Map"), 
												#(#DiffuseMap, "Property", "Map"), 
												#(#SpecularMap, "Property", "Map"), 
												#(#GlossinessMap, "Property", "Map"), 
												#(#SpecularLevelMap, "Property", "Map"), 
												#(#SelfIllumMap, "Property", "Map"), 
												#(#OpacityMap, "Property", "Map"), 
												#(#FilterMap, "Property", "Map"), 
												#(#DiffuseLevel, "Property", "Map"), 
												#(#TranslucentColor, "Property", "Map"), 
												#(#BumpMap, "Property", "Map"), 
												#(#ReflectionMap, "Property", "Map"), 
												#(#RefractionMap, "Property", "Map"), 
												#(#DisplacementMap, "Property", "Map") )
											)										
										)		
									)			
								)--end standard
			)--end case
			
		if map_slots.count == 0 then map_slots = DetectMapSlots map collect_mode
	map_slots 
	)	
	
	fn TMG_renderMaterial mat size_x size_y=
	(
		disablesceneredraw()
		with undo off
		(
			old_selection = selection as array
			max select all
			current_scene_objects = selection as array
			hide current_scene_objects 
			collecLightsState()
			om1 = omniLight pos:[99900.0,99900.0,100300.0] multiplier:1.5
			om2 = omniLight pos:[100100.0,100000.0,99900.0] multiplier:2.0
			case root_sample_object of
			(
				1: s = sphere pos:[100000.0,100000.0,100000.0] mapcoords:true segs:24
				2: (
						s = box rotation:(eulerangles 0 0 30) mapcoords:true 
						s.pos = [100000.0+2.0,100000.0-10.0,100000.0-5.0]
					)
				3: 	s = cylinder pos:[100000.0,100000.0-15.0,100000.0-3.0] mapcoords:true --segs:24
				4: 	(
						s = teapot rotation:(eulerangles 0 0 -35) mapcoords:true radius:15
						s.pos = [100003.0,100000.0-15.0,100000.0-3.0]
					)
			)	
			
			uvw_mod = uvwmap Channel:1
			case root_sample_object of
			(
				1: uvw_mod.mapType=2
				2: uvw_mod.mapType=4
				3: uvw_mod.mapType=1
				4: (
					uvw_mod.mapType=2
					uvw_mod.uTile = 4
					uvw_mod.vTile = 3
					)
			)
			addmodifier s uvw_mod 
			
			for ch in requiredMappingChannles do
			(
				if ch > -1 then 
				(
					uvw_mod = uvwmap() 
					case root_sample_object of
					(
						1: uvw_mod.mapType=2
						2: uvw_mod.mapType=4
						3: uvw_mod.mapType=1
						4: (
							uvw_mod.mapType=2
							uvw_mod.uTile = 4
							uvw_mod.vTile = 3
							)
					)
					uvw_mod.Channel = 0
					uvw_mod.MapChannel = ch 
					addmodifier s uvw_mod 
				)	
			)
			
			s.material = mat
			t_o = targetObject pos:[100000.0,100000.0,100000.0]
			c = TargetCamera target:t_o
			c.pos = [100000.0,100000.0-61,100030.0] 
			map_sample = render camera:c outputsize:[size_x,size_y] vfb:false
			delete c
			delete s
			delete om1
			delete om2
			unhide current_scene_objects 
			select old_selection 
			restoreLightsState()
		)
		enablesceneredraw()
	map_sample 
	)
	

	fn findNextColInRow row col =
	(
		for c = col to 50 do
		(
			if display_map_array[(row-1)*50+c] == false then 
			(
				return c
			)
		)
	50	
	)	
	
	--Experimental WIP Arrange code.	
	fn autoArrangeLoose =
	(
		rows_array = #{}
		for r = 1 to 10 do
		(
			rows_array[r] = False
			for i = 1 to TreeMatoGraph_Nodes.count do
			(
				if TreeMatoGraph_Nodes[i].Row == r then
				(
					rows_array[r] = True
				)
			)	
		)
		if rows_array.count > 0 then
			row_delta = graph_height / ((rows_array as array).count)
		if row_delta < thumb_vspacing then column_delta = thumb_vspacing
		h_offset = thumb_hspacing
		for r in rows_array do
		(
			current_row = #()
			for i = 1 to TreeMatoGraph_Nodes.count do
			(
				if TreeMatoGraph_Nodes[i].Row == r then
				(
					append current_row r
				)
			)	
			if current_row.count > 0 then
			(
				column_delta = graph_width / (current_row.count+1)
				if column_delta < thumb_hspacing then column_delta = thumb_hspacing
				for i = 1 to current_row.count do
				(
					TreeMatoGraph_Nodes[current_row[i]].XPos = i * column_delta + h_offset
					TreeMatoGraph_Nodes[current_row[i]].YPos = (r-1) * row_delta 
					
				)	
			)	
		h_offset += thumb_hspacing	
		)--end r loop
		UiLog "Ready." 2
	)	
	
    fn CollapseTree =
	(
		for n = 1 to TreeMatoGraph_Nodes.count do
		(
			if TreeMatoGraph_Nodes[n].Collapsed then
			(
				branch_array = #(n)
				cnt = 0
				while cnt < branch_array.count do
				(
					cnt +=1
					for l in TreeMatoGraph_Links do
					(
						if l[1] == branch_array[cnt] then append branch_array l[2]
					)
				)
				deleteItem branch_array 1
				for i in branch_array do TreeMatoGraph_Nodes[i].Visible = False
			)	
		)	
		UiLog "Branch Collapsed." 2
	)

    fn ExpandTree =
	(
		for n = 1 to TreeMatoGraph_Nodes.count do
		(
			if TreeMatoGraph_Nodes[n].Collapsed == False then
			(
				branch_array = #(n)
				cnt = 0
				while cnt < branch_array.count do
				(
					cnt +=1
					for l in TreeMatoGraph_Links do
					(
						if l[1] == branch_array[cnt] and TreeMatoGraph_Nodes[l[1]].Collapsed == False then 
							append branch_array l[2]
						else
							l = 10^10
					)
				)
				deleteItem branch_array 1
				for i in branch_array do TreeMatoGraph_Nodes[i].Visible = True
			)	
		)	
		UiLog "Branch Expanded." 2
	)	
	
    fn ExpandBranch node_index =
	(
		branch_array = #(node_index)
		cnt = 0
		while cnt < branch_array.count do
		(
			cnt +=1
			for l in TreeMatoGraph_Links do
			(
				if l[1] == branch_array[cnt] then 
				(
					append branch_array l[2]
				)	
			)
		)
		deleteItem branch_array 1
		for i in branch_array do 
		(
			TreeMatoGraph_Nodes[i].Visible = True
			TreeMatoGraph_Nodes[i].Collapsed = False
		)	
		UiLog "Complete Branch Expanded." 2
	)	

	fn collectRequiredMappingChannels =
	(
		requiredMappingChannles = #()
		for n in TreeMatoGraph_Nodes do
		(
			try
			(
				map_channel = n.MaxNode.coordinates.mapChannel
			)
			catch
			(
				map_channel=-1
			)
			if map_channel != -1 then 
			(
				n.ReqMapCoords = map_channel
				if findItem requiredMappingChannles map_channel == 0 then
					append requiredMappingChannles map_channel
			)	
 		)
		requiredMappingChannles 
	)

	fn UpdateSingleNodeThumbnail hit_node quality =
	(
		collectRequiredMappingChannels()
		freeSceneBitmaps()

		if superclassof TreeMatoGraph_Nodes[hit_node].MaxNode == TextureMap then
		(
			map_bmp = renderMap TreeMatoGraph_Nodes[hit_node].MaxNode scale:100.0 size:[1, 1] filter:true
			TreeMatoGraph_Nodes[hit_node].ShadedColor = (getPixels map_bmp [0,0] 1)[1]
		)	
		else
		(
			isMissingMaps = checkForMissingMaps()
			TreeMatoGraph_Nodes[hit_node].ShadedColor 	= color 120 120 120
			if not isMissingMaps then
			(
				map_bmp = TMG_renderMaterial TreeMatoGraph_Nodes[hit_node].MaxNode 1 1
				TreeMatoGraph_Nodes[hit_node].ShadedColor = (getPixels map_bmp [0,0] 1)[1]
			)
		)
		
		if superclassof TreeMatoGraph_Nodes[hit_node].MaxNode == TextureMap then
		(
			if TreeMatoGraph_Nodes[hit_node].Renderable then
				map_sample = renderMap TreeMatoGraph_Nodes[hit_node].MaxNode scale:100.0 size:[TreeMatoGraph_Nodes[hit_node].Width*quality*zoom_factor ,TreeMatoGraph_Nodes[hit_node].Height*quality*zoom_factor ] filter:true
			else	
				map_sample = bitmap (TreeMatoGraph_Nodes[hit_node].Width*zoom_quality*zoom_factor) (TreeMatoGraph_Nodes[hit_node].Height*zoom_quality*zoom_factor) color:(TreeMatoGraph_Nodes[hit_node].ShadedColor)
		)	
		else
		(
			isMissingMaps = checkForMissingMaps()
			if not isMissingMaps and TreeMatoGraph_Nodes[hit_node].Renderable then
				map_sample = TMG_renderMaterial TreeMatoGraph_Nodes[hit_node].MaxNode (TreeMatoGraph_Nodes[hit_node].Width*quality*zoom_factor ) (TreeMatoGraph_Nodes[hit_node].Height*quality*zoom_factor )
			else
				map_sample = bitmap (TreeMatoGraph_Nodes[hit_node].Width*zoom_quality*zoom_factor) (TreeMatoGraph_Nodes[hit_node].Height*zoom_quality*zoom_factor) color:(TreeMatoGraph_Nodes[hit_node].ShadedColor)
		)
		TreeMatoGraph_Nodes[hit_node].Thumbnail = map_sample 
		storeAppDataRenderable TreeMatoGraph_Nodes[hit_node]
		if TreeMatoGraph_Nodes[hit_node].Visible then 
			graph_bitmap.bitmap = drawNode hit_node back_plane true 1.0
		displayNodeNames()
	)
	
	fn updateAllShadedColors =
	(
		collectRequiredMappingChannels()
		for i = 1 to TreeMatoGraph_Nodes.count do
		(
			if superclassof TreeMatoGraph_Nodes[i].MaxNode == TextureMap then
			(
				map_bmp = renderMap TreeMatoGraph_Nodes[i].MaxNode scale:100.0 size:[1, 1] filter:true
				TreeMatoGraph_Nodes[i].ShadedColor = (getPixels map_bmp [0,0] 1)[1]
			)	
			else
			(
				isMissingMaps = checkForMissingMaps()
				TreeMatoGraph_Nodes[i].ShadedColor 	= color 120 120 120
				if not isMissingMaps then
				(
					map_bmp = TMG_renderMaterial TreeMatoGraph_Nodes[i].MaxNode 1 1
					TreeMatoGraph_Nodes[i].ShadedColor = (getPixels map_bmp [0,0] 1)[1]
				)
			)
			TreeMatoGraph_Nodes[i].Thumbnail = 	bitmap (TreeMatoGraph_Nodes[i].Width*zoom_quality*zoom_factor) (TreeMatoGraph_Nodes[i].Height*zoom_quality*zoom_factor) color:(TreeMatoGraph_Nodes[i].ShadedColor)
		)--end i loop
	)
	
	fn buildTree mat =
	(
		copy graph_bmp back_plane
		TreeMatoGraph_Currently_Edited_Tree = mat
		UiLog "Building Material Tree..." 6
		collect_nodes = #(#(mat,mat,0,0,0))
		collect_links = #()
		parent_array = #()
		final_parent_array = #(1)
		cnt = 0
		TreeMatoGraph_Nodes =#()
		TreeMatoGraph_Links =#()
		current_parent = 1
		
		new_node = tree_node()
		new_node.MaxNode = mat
		new_node.Name = (mat.name+ "[" + (classof mat as string)+"]")
		case view_order of
		(
			1: (
				new_node.XPos = graph_width/2.0-thumb_width
				new_node.YPos = 14
			)
			2:	(
				new_node.YPos = graph_height/2.0-thumb_width
				new_node.XPos = 14
			)	
		)	
		new_node.Width = thumb_width*1.5
		new_node.Height = thumb_height*1.5
		new_node.Renderable = restoreAppDataRenderable new_node 
		new_node.IsRoot = True
		new_node.Visible = restoreAppDataVisible new_node
		new_node.Collapsed = restoreAppDataCollapsed new_node

		new_node.Row = 1 
		new_node.Column = 1
		new_node.Selected = False
		append TreeMatoGraph_Nodes new_node
		
		current_depth = 1
		while cnt < collect_nodes.count do
		(
			cnt +=1
			current_cnt = cnt
			try(check_class = superclassof collect_nodes[cnt][1].object)catch(check_class = undefined)
			if check_class == Material or check_class == TextureMap then current_parent = collect_nodes[cnt][1]
			for m = 1 to collect_nodes[cnt][1].numsubs do
			(
				if collect_nodes[cnt][1][m] != undefined then
				(
					append collect_nodes #(collect_nodes[cnt][1][m], current_parent, cnt, 0,0)
					collect_nodes[cnt][4]=current_cnt
					collect_nodes[cnt][5]=current_cnt+m
				)	
			)--end m loop
		)--end while
		
		already_used_array = #()
		already_used_index = #()
		for i = 2 to collect_nodes.count do
		(	
			try
			(
			if superclassof collect_nodes[i][1].object == TextureMap then
			(
				final_parent_index = findClosestParent i
				parent_index = findItem final_parent_array final_parent_index 
				check_instances = findItem already_used_array collect_nodes[i][1].object
				if check_instances == 0 then
				(
					map_name = collect_nodes[i][1].object.name+ "[" + (classof collect_nodes[i][1].object as string)+"]"
					new_node = tree_node()
					new_node.Name = map_name
					new_node.XPos = TreeMatoGraph_Nodes.count*thumb_width
					new_node.YPos = thumb_height+14+parent_index*(thumb_height+thumb_vspacing)
					new_node.Width = thumb_width
					new_node.Height = thumb_height
					new_node.MaxNode = collect_nodes[i][1].object
					new_node.Renderable = restoreAppDataRenderable new_node 
					new_node.Visible = restoreAppDataVisible new_node
					new_node.Collapsed = restoreAppDataCollapsed new_node
					new_node.Row = 1 
					new_node.Column = 1
					new_node.Selected = False
					
					append TreeMatoGraph_Nodes new_node
					
					append TreeMatoGraph_Links #(parent_index,TreeMatoGraph_Nodes.count)
					append final_parent_array i
					append already_used_array collect_nodes[i][1].object
					append already_used_index TreeMatoGraph_Nodes.count
				)
				else	
				(
					append TreeMatoGraph_Links #(parent_index,already_used_index[check_instances])
				)
			)
			)catch()
			try
			(
			if superclassof collect_nodes[i][1]== Material then
			(
				final_parent_index = findClosestParent i
				parent_index = findItem final_parent_array final_parent_index 
				check_instances = findItem already_used_array collect_nodes[i][1]
				if check_instances == 0 then
				(
					map_name = collect_nodes[i][1].name+ "[" + (classof collect_nodes[i][1] as string)+"]"
					try(mat_color = collect_nodes[i][1].diffuse)catch(mat_color = color 210 210 210)
					
					new_node = tree_node()
					new_node.Name = map_name
					new_node.XPos = TreeMatoGraph_Nodes.count*thumb_width
					new_node.YPos = thumb_height+14+parent_index*(thumb_height+thumb_vspacing)
					new_node.Width = thumb_width
					new_node.Height = thumb_height
					new_node.MaxNode = collect_nodes[i][1]
					new_node.Renderable = restoreAppDataRenderable new_node 
					new_node.Visible = restoreAppDataVisible new_node
					new_node.Collapsed = restoreAppDataCollapsed new_node
					
					new_node.Row = 1 
					new_node.Column = 1
					new_node.Selected = False					
					append TreeMatoGraph_Nodes new_node
					
					append TreeMatoGraph_Links #(parent_index,TreeMatoGraph_Nodes.count)
					append final_parent_array i
					append already_used_array collect_nodes[i][1]
					append already_used_index TreeMatoGraph_Nodes.count					
				)
				else	
				(
					append TreeMatoGraph_Links #(parent_index,already_used_index[check_instances])
				)				
			)
			)catch()			
			try
			(
			if superclassof collect_nodes[i][1].object == Material then
			(
				final_parent_index = findClosestParent i
				parent_index = findItem final_parent_array final_parent_index 
				check_instances = findItem already_used_array collect_nodes[i][1].object
				if check_instances == 0 then
				(
					map_name = collect_nodes[i][1].object.name + "[" + (classof collect_nodes[i][1].object as string)+"]"
					new_node = tree_node()
					new_node.Name = map_name
					new_node.MaxNode = collect_nodes[i][1].object
					new_node.XPos = TreeMatoGraph_Nodes.count*thumb_width
					new_node.YPos = thumb_height+14+parent_index*(thumb_height+thumb_vspacing)
					new_node.Width = thumb_width
					new_node.Height = thumb_height
					new_node.Visible = restoreAppDataVisible new_node
					new_node.Collapsed = restoreAppDataCollapsed new_node
					
					new_node.Renderable = restoreAppDataRenderable new_node 
					new_node.Row = 1 
					new_node.Column = 1
					new_node.Selected = False					
					append TreeMatoGraph_Nodes new_node
					
					append TreeMatoGraph_Links #(parent_index,TreeMatoGraph_Nodes.count)
					append final_parent_array i
					append already_used_array collect_nodes[i][1].object
					append already_used_index TreeMatoGraph_Nodes.count					
				)
				else	
				(
					append TreeMatoGraph_Links #(parent_index,already_used_index[check_instances])
				)		
			)
			)catch()			
		)--end loop
		
		updateAllShadedColors()
		
		display_map_array = #()
		for i = 1 to 500 do append display_map_array false
		last_row_used = true
		row_offset = 0
		for i = 1 to TreeMatoGraph_Nodes.count do
		(
			if last_row_used then 
			(
				last_row_used = false 
			)	
			for j = 1 to TreeMatoGraph_Links.count do
			(
				if TreeMatoGraph_Links[j][1] == i then
				(
					parent_row = TreeMatoGraph_Nodes[i].Row+1
					parent_col = TreeMatoGraph_Nodes[i].Column
					current_col = findNextColInRow parent_row parent_col
					TreeMatoGraph_Nodes[TreeMatoGraph_Links[j][2]].Row = parent_row
					if (parent_row/2) as float == (parent_row/2.0) then row_offset = thumb_width/2.0 else row_offset = 0.0
					TreeMatoGraph_Nodes[TreeMatoGraph_Links[j][2]].Column = current_col
					case view_order of
					(
						1: (
							TreeMatoGraph_Nodes[TreeMatoGraph_Links[j][2]].XPos = thumb_width/2.0 + current_col*(thumb_width+thumb_hspacing) + row_offset 
							TreeMatoGraph_Nodes[TreeMatoGraph_Links[j][2]].YPos = 14+(parent_row-1)*thumb_height*2.0 
						)
						2: (
							TreeMatoGraph_Nodes[TreeMatoGraph_Links[j][2]].YPos = thumb_height/2.0 + current_col*(thumb_height+thumb_vspacing) + row_offset 
							TreeMatoGraph_Nodes[TreeMatoGraph_Links[j][2]].XPos = 14+(parent_row-1)*thumb_width*2.0 
						)
					)	
					last_row_used = true
					display_map_array[(parent_row-1)*50+current_col] = true
				)
			)
		)--end i
		if auto_update.checked then registerMaterialPropertiesCallback()
		TreeMatoGraph_StructureChanged = false
		CollapseTree()
		setChangedPropertyFlag ()
--		UiLog "Ready." 2
--		autoArrangeLoose()
	)
	
	fn findParents node =
	(
		dependent_nodes = #()
		for l in TreeMatoGraph_Links do
			if l[2] == node then append dependent_nodes l[1]
	dependent_nodes
	)

	fn findChildren node =
	(
		dependent_nodes = #()
		for l in TreeMatoGraph_Links do
			if l[1] == node then append dependent_nodes l[2]
	dependent_nodes
	)
	
	fn FindMultipleSelection from_pos to_pos = 
	(
		selected_count = 0
		if from_pos.x > to_pos.x then
		(
			upper_left_x = to_pos.x
			lower_right_x = from_pos.x
		)	
		else
		(
			upper_left_x = from_pos.x
			lower_right_x = to_pos.x
		)
		if from_pos.y > to_pos.y then
		(
			upper_left_y = to_pos.y
			lower_right_y = from_pos.y
		)	
		else
		(
			upper_left_y = from_pos.y
			lower_right_y = to_pos.y
		)	
		multiple_selection = #()
		
		for i = 1 to TreeMatoGraph_Nodes.count do
		(
			obj = TreeMatoGraph_Nodes[i]
			
			OriginalWidth =	obj.Width
			OriginalHeight = obj.Height
			actual_target_x = obj.XPos*scale_factor+origin_offset.x+OriginalWidth/2-OriginalWidth*scale_factor/2
			actual_target_y = obj.YPos*scale_factor+origin_offset.y+OriginalHeight/2-OriginalHeight*scale_factor/2
			actual_target_x2 = actual_target_x +obj.Width*scale_factor
			actual_target_y2 = actual_target_y +obj.Height*scale_factor
			
			if actual_target_x2 < lower_right_x and \
			   actual_target_x > upper_left_x and \
			   actual_target_y2 < lower_right_y and \
			   actual_target_y > upper_left_y then
			(
				obj.Selected = True
				append multiple_selection i
				selected_count += 1
			)
		)
		selected_count 
	)--end fn
	
	fn UnselectAllNodes =
	(
		for i in TreeMatoGraph_Nodes do i.Selected = False
	)
	
	
	fn reloadMaterialTree =
	(
		if TreeMatoGraph_Currently_Edited_Tree != undefined then 
		(
			store_old_positions()
			buildTree TreeMatoGraph_Currently_Edited_Tree 
			restoreTreePosition()	
			restore_old_positions()	
			graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1
			UiLog "Reloaded Current Material Tree." 2
			displayNodeNames()
		)
	)	
	on rescan_tree pressed do reloadMaterialTree()

	
	fn showParentChannels current_node =
	(
			TMG_t_map = TreeMatoGraph_Nodes[current_node].MaxNode
			parent_list = findParents current_node
			parent_list = sort parent_list 
			last_parent = 0
			for d in parent_list do
			(
				if last_parent != d then 
				(
					parent_count = 0
					TMG_s_map = TreeMatoGraph_Nodes[d].MaxNode

					OriginalWidth = TreeMatoGraph_Nodes[d].Width
					OriginalHeight = TreeMatoGraph_Nodes[d].Height
					source_pos_x = TreeMatoGraph_Nodes[d].XPos*scale_factor+origin_offset.x+OriginalWidth/2-OriginalWidth*scale_factor/2
					source_pos_y = TreeMatoGraph_Nodes[d].YPos*scale_factor+origin_offset.y+OriginalHeight/2-OriginalHeight*scale_factor/2
					
					source_slots_list = collectMapSlots TMG_s_map undefined
					for i in source_slots_list do
					(
						if i[2] == "Property" then
						(
							if getProperty TMG_s_map i[1] == TMG_t_map and TreeMatoGraph_Nodes[d].Visible then 
							(
								type_counter += 1
								parent_count += 1
								y = source_pos_y + (parent_count-1)*14 + TreeMatoGraph_Nodes[d].Height*scale_factor
								if y < graph_height-12 then
								(
									Type_Label[type_counter].text = (i[1] as string)
									Type_Label[type_counter].pos.x = source_pos_x
									Type_Label[type_counter].pos.y = y
								)	
							)	
						)	
						else
						(
							try(test_value = execute ("TMG_s_map"+i[2]))catch(test_value = undefined)
							if  test_value == TMG_t_map and TreeMatoGraph_Nodes[d].Visible then 
							(
								type_counter += 1
								parent_count += 1
								y = source_pos_y + (parent_count-1)*14 + TreeMatoGraph_Nodes[d].Height*scale_factor
								if y < graph_height-12 then
								(
									Type_Label[type_counter].text = (i[1] as string)
									Type_Label[type_counter].pos.x = source_pos_x
									Type_Label[type_counter].pos.y = y
								)	
							)--end if	
						)--end else	
					)--end i loop
				)--end if 
				last_parent = d
			)--end d loop
	)--end fn	
	
	fn showChildChannels current_node =
	(
			TMG_t_map = TreeMatoGraph_Nodes[current_node].MaxNode
			
			children_list = findChildren current_node
			children_list = sort children_list 
			last_child = 0
			for d in children_list do
			(
				if last_child != d then 
				(
					children_count = 0
					TMG_s_map = TreeMatoGraph_Nodes[d].MaxNode
					
					OriginalWidth = TreeMatoGraph_Nodes[d].Width
					OriginalHeight = TreeMatoGraph_Nodes[d].Height
					source_pos_x = TreeMatoGraph_Nodes[d].XPos*scale_factor+origin_offset.x+OriginalWidth/2-OriginalWidth*scale_factor/2
					source_pos_y = TreeMatoGraph_Nodes[d].YPos*scale_factor+origin_offset.y+OriginalHeight/2-OriginalHeight*scale_factor/2
					
					target_slots_list = collectMapSlots TMG_t_map undefined
					for i in target_slots_list do
					(
						if i[2] == "Property" then
						(
							if getProperty TMG_t_map i[1] == TMG_s_map and TreeMatoGraph_Nodes[d].Visible then 
							(
								type_counter += 1
								children_count += 1
								y = source_pos_y + (children_count-1)*14  + TreeMatoGraph_Nodes[d].Height*scale_factor
								if y < graph_height-12 then
								(
									Type_Label[type_counter].text = (i[1] as string)
									Type_Label[type_counter].pos.x = source_pos_x 
									Type_Label[type_counter].pos.y = y
								)	
							)	
						)	
						else
						(
							try(test_value = execute ("TMG_t_map"+i[2]))catch(test_value = undefined)
							if  test_value == TMG_s_map and TreeMatoGraph_Nodes[d].Visible then 
							(
								type_counter += 1
								children_count += 1
								y = source_pos_y + (children_count-1)*14+ TreeMatoGraph_Nodes[d].Height*scale_factor
								if y < graph_height-12 then
								(
									Type_Label[type_counter].text = (i[1] as string)
									Type_Label[type_counter].pos.x = source_pos_x
									Type_Label[type_counter].pos.y = y
								)
							)--end if	
						)--end else	
					)--end i loop
				)--end if 
				last_child = d
			)--end d loop
	)--end fn	
	
	fn unlinkFromAll current_node current_maxnode =
	(
		for n in TreeMatoGraph_Nodes do
		(
			TMG_target_map = n.MaxNode
			target_slots = collectMapSlots TMG_target_map undefined
			for t = 1 to target_slots.count do
			(
				if target_slots[t][2] == "Property" then
				(
					if getProperty TMG_target_map target_slots[t][1] == current_maxnode then 
					(
						setProperty TMG_target_map target_slots[t][1] undefined
					)
				)
				else
				(	
					try
					(
						txt = "TMG_target_map"+target_slots[t][2]+ "\n"
						if execute (txt) == current_maxnode then
						(
							txt = "TMG_target_map"+target_slots[t][2]+ "= undefined\n"
							execute (txt)
						)	
					)
					catch()
				)
			)--end t loop
		)--end n loop
		for l = TreeMatoGraph_Links.count to 1 by -1 do
		(
			if TreeMatoGraph_Links[l][1] == current_node or TreeMatoGraph_Links[l][2] == current_node then 
			(
				deleteItem TreeMatoGraph_Links l
			)	
		)
	)	
	
	fn deleteNodeFromTree current_node  =
	(
		current_maxnode = TreeMatoGraph_Nodes[current_node].MaxNode
		current_maxnode_name = current_maxnode.name
		q = querybox ("Are you sure you want to DELETE ["+current_maxnode_name+"] ?") title:"TreeMatoGraph"
		if q then
		(
			unlinkFromAll current_node current_maxnode
			deleteItem TreeMatoGraph_Nodes current_node
			store_old_positions()
			buildTree TreeMatoGraph_Currently_Edited_Tree 
			restore_old_positions()
			graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1
			UiLog ("Deleted Node "+current_maxnode_name) 2			
			displayNodeNames()
		)
		else
 		(
			UiLog ("Delete Node Canceled.") 4
		)	
	)
	
	fn unlinkNodeFromTree current_node  =
	(
		current_maxnode = TreeMatoGraph_Nodes[current_node].MaxNode
		current_maxnode_name = current_maxnode.name
		q = querybox ("Are you sure you want to UNLINK ["+current_maxnode_name+"]\nfrom all parent nodes?") title:"TreeMatoGraph"
		if q then
		(
			unlinkFromAll current_node current_maxnode
			store_old_positions()
			buildTree TreeMatoGraph_Currently_Edited_Tree 
			restore_old_positions()
			graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1
			UiLog "Ready." 2			
			displayNodeNames()
		)
		else
 		(
			UiLog ("Unlink Node From All Canceled.") 4
		)	
	)
	
	fn createConnection pos=
	(
		if ConnectMode then
		(
			current_node = NodeHitTest pos
			if current_node > 0 and current_node != connect_source_node then
			(
				TMG_target_map = TreeMatoGraph_Nodes[current_node].MaxNode
				TMG_source_map = TreeMatoGraph_Nodes[connect_source_node].MaxNode
				cannot_connect = (superclassof TMG_source_map == Material and superclassof TMG_target_map == TextureMap)
				if cannot_connect then TreeMatoGraph_rollout.UiLog ("Cannot Link Material To Map!") 4
				source_slots = collectMapSlots TMG_source_map (superclassof TMG_source_map)
				for i in source_slots do
				(
					if i[2] == "Property" then
					(
						if getProperty TMG_source_map i[1] == TMG_target_map then 
						(
							cannot_connect = true
							TreeMatoGraph_rollout.UiLog ("Cannot Link - Circular Dependency!") 4
						)	
					)	
					else
					(
						try(test_value = execute ("TMG_source_map"+i[2]))catch(test_value = undefined)
						if  test_value == TMG_target_map then 
						(
							cannot_connect = true
							TreeMatoGraph_rollout.UiLog ("Cannot Link - Circular Dependency!") 4
						)	
					)	
				)
				
				if cannot_connect then 
				(
					destroyDialog TreeMatoGraph_link_map_rollout
				)
				else
				(
					target_slots = collectMapSlots TMG_target_map (superclassof TMG_source_map)
					if target_slots.count > 0 then
					(
						tmg_pos = getDialogPos TreeMatoGraph_rollout 
						rollout_height = (100+target_slots.count*16)
						if rollout_height > 400 then rollout_height = 400
						createDialog TreeMatoGraph_link_map_rollout 200 rollout_height (TreeMatoGraph_Nodes[current_node].XPos*scale_factor+tmg_pos.x) (TreeMatoGraph_Nodes[current_node].YPos+TreeMatoGraph_Nodes[current_node].Height+20+tmg_pos.y  )  --modal:true
						TreeMatoGraph_link_map_rollout.label_source.text = (TMG_source_map.name + "[" + (classof TMG_source_map) as string +"]" )
						TreeMatoGraph_link_map_rollout.label_target.text = (TMG_target_map.name + "[" + (classof TMG_target_map) as string +"]" )
						local names_array = #()
						for i in target_slots do
						(
							if i[2] == "Property" then 
							(
								current_value = getProperty TMG_target_map i[1]
							)	
							else
							(
								try(current_value = execute("TMG_target_map"+ i[2]))catch(current_value=undefined)
							)	
							if current_value == undefined then
								current_value_string = ""
							else
								try(current_value_string = " - "+current_value.name)catch(current_value_string = "")
							append names_array ((i[1] as string) + current_value_string)
						)	
						
						TreeMatoGraph_link_map_rollout.map_list.items = names_array
					)
				)
			)
			ConnectMode = false
		)	
	)--end connect function
	
	fn destroyConnection pos=
	(
		if DisconnectMode then
		(
			store_old_positions()
			current_node = NodeHitTest pos
			if current_node > 0 and current_node != connect_source_node then
			(
				TMG_target_map = TreeMatoGraph_Nodes[current_node].MaxNode
				TMG_source_map = TreeMatoGraph_Nodes[connect_source_node].MaxNode
				target_slots = collectMapSlots TMG_target_map undefined
				linked_slots = #()
				for t = 1 to target_slots.count do
				(
					if target_slots[t][2] == "Property" then
					(
						if getProperty TMG_target_map target_slots[t][1] == TMG_source_map then 
						(
							append linked_slots target_slots[t]
						)
					)
					else
					(	
						try(test_value = execute ("TMG_target_map"+target_slots[t][2]))catch(test_value = undefined)
						if test_value == TMG_source_map then append linked_slots target_slots[t]
					)
				)
				if linked_slots.count > 0 then 
				(
					tmg_pos = getDialogPos TreeMatoGraph_rollout 
					local names_array = #()
					for i in linked_slots do append names_array (i[1] as string)
					rollout_height = (100+names_array.count*16)
					if rollout_height > 400 then rollout_height = 400
					createDialog TreeMatoGraph_unlink_map_rollout 200 rollout_height (TreeMatoGraph_Nodes[current_node].XPos*scale_factor+tmg_pos.x) (TreeMatoGraph_Nodes[current_node].YPos*scale_factor+TreeMatoGraph_Nodes[current_node].Height+20+tmg_pos.y  ) --modal:true
					TreeMatoGraph_unlink_map_rollout.label_source.text = (TMG_source_map.name + "[" + (classof TMG_source_map) as string +"]" )
					TreeMatoGraph_unlink_map_rollout.label_target.text = (TMG_target_map.name + "[" + (classof TMG_target_map) as string +"]" )
					
					TreeMatoGraph_unlink_map_rollout.map_list.items = names_array
				)
				else
				(
					UiLog "Nothing to Unlink." 4
				)	
			)
			DisconnectMode = false
		)	
	)--end connect function
	
	----------------
	-- VIEW SCALE --
	----------------	

	fn view_scale_update = 
	(
		copy graph_bmp back_plane
		graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1		
		displayNodeNames()
	)	
	
	on view_scale_factor changed val do 
	(
		scale_factor = val/100.0
		view_scale_update()
	)		
	on view_scale_50 pressed do 
	(
		scale_factor = 0.5
		view_scale_factor.value = 50
		view_scale_update()
	)	
	on view_scale_100 pressed do 
	(
		scale_factor = 1.0
		view_scale_factor.value = 100
		view_scale_update()
	)	
	on view_scale_200 pressed do 
	(
		scale_factor = 2.0
		view_scale_factor.value = 200
		view_scale_update()
	)		
	
	------------------------
	--LEFT BUTTON RELEASED--
	------------------------
	
	on TreeMatoGraph_rollout lbuttonup pos do
	(
		if ConnectMode then createConnection pos
		if DisconnectMode then destroyConnection pos
		setSysCur #arrow
		LButtonPressed =false
		start_pos = [0,0]
		if multiple_selection_mode then
		(
			multiple_selection_end = pos
			multiple_selection_mode = false
			
			if keyboard.controlPressed or zoomwin_mode.checked then
			(
			
				upper_left = [0,0]
				lower_right = [0,0]
				actual_start = ((multiple_selection_start-origin_offset)/scale_factor)
				actual_end = ((multiple_selection_end-origin_offset)/scale_factor)
				
				if actual_start.x > actual_end.x then upper_left.x = actual_end.x else upper_left.x = actual_start.x 
				if actual_start.y > actual_end.y then upper_left.y = actual_end.y else upper_left.y = actual_start.y


				full_width = abs (multiple_selection_start.x - multiple_selection_end.x)/scale_factor
				full_height = abs (multiple_selection_start.y - multiple_selection_end.y)/scale_factor
				
				if full_width / full_height > graph_width/ graph_height then
					new_scale_factor = graph_width/scale_factor / full_width
				else	
					new_scale_factor = graph_height/scale_factor / full_height
				
				old_scale_factor = scale_factor 
				scale_factor *= new_scale_factor
				if scale_factor > 9.99 then 
				(
					scale_factor = old_scale_factor 
					UiLog ("Invalid Zoom Region Size!") 4
				)
				else
				(	
					if scale_factor < 0.05 then scale_factor = 0.05
					origin_offset = upper_left*scale_factor
					origin_offset.x = -origin_offset.x
					origin_offset.y = -origin_offset.y
					view_scale_factor.value = scale_factor *100.0
					view_scale_update()	
					UiLog ("Region Zoom to "+ view_scale_factor.value as string+ "%") 2 	
				)
			)
			else
			(
				if not keyboard.altPressed then UnselectAllNodes()
				FindMultipleSelection multiple_selection_start multiple_selection_end
				case multiple_selection.count of
				(
					0: ( if not keyboard.altPressed then 
							UiLog ("Deselected All Nodes.") 2 
						else	
							UiLog ("No Changes to Selection.") 2 
						)
					1: (
						if not keyboard.altPressed then 
							UiLog ("Selected One Node.") 2 
						else
							UiLog ("Added One Node To Selection.") 2 
						)
							
					default: ( 
						if not keyboard.altPressed then 
							UiLog ("Selected "+multiple_selection.count as string +" Nodes.") 2 
						else	
							UiLog ("Added "+multiple_selection.count as string +" Nodes To Selection.") 2 
						)
				)	
			)	
		)	
		copy graph_bmp back_plane
		graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1	
		displayNodeNames()
		gc light:true
	)	
	
	on TreeMatoGraph_rollout rbuttonDblClk pos do
	(
		current_node = NodeHitTest pos
		if current_node == 0 then
		(
			move_mode.checked = true
			link_mode.checked = del_mode.checked = unlink_mode.checked = pan_mode.checked = zoom_mode.checked = zoomwin_mode.checked = false
		)
	)
	
	fn InitializeLinking current_node =
	(
		LButtonPressed = true
		ConnectMode = true
		link_mode.checked = true
		move_mode.checked = unlink_mode.checked = zoom_mode.checked = pan_mode.checked = zoomwin_mode.checked = false		
		connect_source_node = current_node
		copy graph_bmp background_plane 
		background_plane = drawAllNodes background_plane #() 1 1 1
		graph_bitmap.bitmap = background_plane 
	)
	
	fn InitializeUnlinking current_node =
	(
		LButtonPressed = true
		DisconnectMode = true
		unlink_mode.checked = true
		move_mode.checked = link_mode.checked = zoom_mode.checked = pan_mode.checked = zoomwin_mode.checked = false		
		connect_source_node = current_node
		copy graph_bmp background_plane 
		background_plane = drawAllNodes background_plane #() 1 1 1
		graph_bitmap.bitmap = background_plane 
	)
	
	fn CloneNode current_node =
	(
		append TreeMatoGraph_Nodes (copy TreeMatoGraph_Nodes[current_node])
		TreeMatoGraph_Nodes[TreeMatoGraph_Nodes.count].MaxNode = copy TreeMatoGraph_Nodes[current_node].MaxNode
		TreeMatoGraph_Nodes[TreeMatoGraph_Nodes.count].MaxNode.name += "_Copy"
		UiLog ("Cloned Node "+TreeMatoGraph_Nodes[current_node].MaxNode.name) 2		
		TreeMatoGraph_Nodes.count
	)
	
	------------------------
	--LEFT BUTTON PRESSED--
	------------------------

	on TreeMatoGraph_rollout lbuttondown pos do
	(
		old_pos = pos
		current_node = NodeHitTest pos
		if current_node > 0 and del_mode.checked then
		(
			deleteNodeFromTree current_node 
		)
		
		if current_node > 0 and LButtonPressed == false and ( link_mode.checked or (keyboard.ControlPressed and right_click_behavior==1) ) then
		(
			InitializeLinking current_node
		)
		
		if current_node > 0 and LButtonPressed == false and move_mode.checked and ( not keyboard.ControlPressed and not keyboard.AltPressed ) then
		(
			LButtonPressed = true
			start_move_pos = pos
			if multiple_selection.count == 0 then 
			(
				if keyboard.ShiftPressed then
				(
					copy graph_bmp background_plane 
					background_plane = drawAllNodes background_plane #() 1 1 1
					current_node = CloneNode current_node
					copy background_plane back_plane
					graph_bitmap.bitmap = drawNode current_node back_plane 1 1.0
				)	
				else
				(
					copy graph_bmp background_plane 
					background_plane = drawAllNodes background_plane #(current_node) 1000 1000 1
					copy background_plane back_plane
					back_plane = drawMoveNodeLines back_plane #(current_node) 10 5 link_parent_color link_child_color
					graph_bitmap.bitmap = drawNode current_node back_plane 1 1.0
				)
			)	
			else
			(
				multiple_selection = #()
				for i = 1 to TreeMatoGraph_Nodes.count do if TreeMatoGraph_Nodes[i].Selected then append multiple_selection i
				copy graph_bmp background_plane 
				background_plane = drawAllNodes background_plane multiple_selection 1000 1000 1
				copy background_plane back_plane
				back_plane = drawMoveNodeLines back_plane multiple_selection 10 5 link_parent_color link_child_color
				for i in multiple_selection do
				(
					back_plane = drawNode i back_plane 1 1.0
				)
				graph_bitmap.bitmap = back_plane 				
			)	
		)
		
		if (current_node > 0 and LButtonPressed == false) and (unlink_mode.checked or (keyboard.AltPressed and right_click_behavior==1) ) then
		(
			InitializeUnlinking current_node
		)
		
		if pan_mode.checked then 
		(
			start_pos = pos
			LButtonPressed = true
			pan_offset = [0.0,0.0]
			current_node = 0
			displayNodeNames()
		)	

		if current_node > 0 and not del_mode.checked then 
		(
			node_to_rename = TreeMatoGraph_Nodes[current_node].MaxNode
			map_edit_name.text = node_to_rename.name
		)	
		
		if current_node == 0 then 
		(
			multiple_selection_start = pos
			multiple_selection_mode = true
			copy graph_bmp background_plane 
			background_plane = drawAllNodes background_plane #() 1 1 1
			graph_bitmap.bitmap = background_plane 
		)	
	)	
	
	on map_edit_name changed txt do
	(
		if node_to_rename != undefined then node_to_rename.name= txt
		displayNodeNames()
	)
	
	-------------------------
	--RIGHT BUTTON RELEASED--
	-------------------------

	on TreeMatoGraph_rollout rbuttonup pos do
	(
		current_node = NodeHitTest pos
		if right_click_behavior == 2 and current_node > 0 then
		(
			if ConnectMode then createConnection pos
			if DisconnectMode then destroyConnection pos
		)
		start_pos = [0,0]
		copy graph_bmp back_plane
		graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1	
		displayNodeNames()
		move_mode.checked = true
		ConnectMode = DisconnectMode = LButtonPressed = RButtonPressed = false
		unlink_mode.checked = link_mode.checked = zoom_mode.checked = pan_mode.checked = del_mode.checked = zoomwin_mode.checked = false		
	)	
	
	------------------------
	--RIGHT BUTTON PRESSED--
	------------------------

	on TreeMatoGraph_rollout rbuttondown pos do
	(
		current_node = NodeHitTest pos

		if current_node > 0 and RButtonPressed == false then
		(
			case right_click_behavior of
			(
				1: popUpMenu TMG_NodeRichtClick pos:pos rollout:TreeMatoGraph_rollout
				2: (
					if keyboard.controlPressed then
					(
						popUpMenu TMG_NodeRichtClick pos:pos rollout:TreeMatoGraph_rollout
					)
					else
					(
						RButtonPressed = true
						connect_source_node = current_node
						copy graph_bmp background_plane 
						background_plane = drawAllNodes background_plane #() 1 1 1
						graph_bitmap.bitmap = background_plane 
						if keyboard.altPressed then
						(
							DisconnectMode = true
							move_mode.checked = link_mode.checked = zoom_mode.checked = pan_mode.checked =  zoomwin_mode.checked =false
							unlink_mode.checked = true			
						)
						else
						(
							ConnectMode = true
							move_mode.checked = unlink_mode.checked = zoom_mode.checked = pan_mode.checked = zoomwin_mode.checked = false		
							link_mode.checked = true
						)	
					)	
				)
			)	
		)
		else
		(
			setSysCur #arrow
			if move_mode.checked then
			(
				popUpMenu TMG_RCMenu pos:pos rollout:TreeMatoGraph_rollout
			)	
			else
			(
				start_pos = [0,0]
				copy graph_bmp back_plane
				graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1	
				displayNodeNames()
				move_mode.checked = true
				ConnectMode = DisconnectMode = LButtonPressed = false
				unlink_mode.checked = link_mode.checked = zoom_mode.checked = pan_mode.checked = del_mode.checked = zoomwin_mode.checked =false		
			)		
		)
	)	
	
	fn drawLinkingLines pos =
	(
		copy background_plane back_plane
		back_plane = drawConnectNodeLine back_plane connect_source_node (pos-origin_offset) 4 2 link_link_color [0,0,0]
		graph_bitmap.bitmap = back_plane 
		displayNodeNames()	
	)
	
	fn drawUnlinkLines pos = 
	(
		copy background_plane back_plane
		back_plane = drawConnectNodeLine back_plane connect_source_node (pos-origin_offset) 4 2 link_unlink_color [0,0,0]
		graph_bitmap.bitmap = back_plane 
		displayNodeNames()		
	)

	------------------
	--MIDDLE BUTTON --
	------------------	
	
	on TreeMatoGraph_rollout mbuttondown pos do
	(
		start_pos = pos
		MButtonPressed = true
		pan_offset = [0.0,0.0]
		current_node = 0
		displayNodeNames()
	)	
	
	on TreeMatoGraph_rollout mbuttonDblClk pos do
	(
		if keyboard.controlPressed then
		(
			scale_factor = 1.0
			view_scale_factor.value = 100
			view_scale_update()
		)
		else
		(
			origin_offset = [0.0,0.0]
			current_node = 0
			copy graph_bmp back_plane
			graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1	
			displayNodeNames()
		)	
	)		
	
	on TreeMatoGraph_rollout mbuttonup pos do
	(
		setSysCur #arrow
		MButtonPressed = false
		start_pos = [0,0]
		pan_offset = [0.0,0.0]
		copy graph_bmp back_plane
		graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1	
		displayNodeNames()
	)		
	
	-----------------
	-- MOUSE MOVED --
	-----------------	
	
	on TreeMatoGraph_rollout mousemove pos do
	(
		st = timestamp()
		ready_to_resize = true
		
		if (LButtonPressed and link_mode.checked) then drawLinkingLines pos
		
		if ConnectMode then 
		(
			move_mode.checked = unlink_mode.checked = pan_mode.checked = zoom_mode.checked = zoomwin_mode.checked = false
			link_mode.checked = true
			drawLinkingLines pos
		)	
		
		if DisconnectMode then 
		(
			move_mode.checked = link_mode.checked = pan_mode.checked = zoom_mode.checked = zoomwin_mode.checked = false
			unlink_mode.checked = true
			drawUnlinkLines pos
		)
		
		if multiple_selection_mode and not pan_mode.checked then
		(
			multiple_selection_end = pos
			copy background_plane back_plane
			drawSelectionWindow back_plane multiple_selection_start multiple_selection_end
			graph_bitmap.bitmap = back_plane 
			displayNodeNames()				
		)

		if MButtonPressed and keyboard.controlPressed then
		(
			if last_scale_pos != pos then
			(
				scale_delta = (start_pos - pos)/2000.0
				scale_factor += scale_delta.y
				if scale_factor > 5.0 then scale_factor = 5.0
				if scale_factor < 0.05 then scale_factor = 0.05
				view_scale_factor.value = scale_factor*100.0
				view_scale_update()
				last_scale_pos = pos
			)	
		)
		
		if LButtonPressed and move_mode.checked and not keyboard.ControlPressed then
		(
			setSysCur #move
			if new_pos != old_pos then
			(
				if multiple_selection.count == 0 then
				(
					try
					(
						TreeMatoGraph_Nodes[current_node].XPos += (pos-start_move_pos ).x/scale_factor
						TreeMatoGraph_Nodes[current_node].YPos += (pos-start_move_pos ).y/scale_factor
						copy background_plane back_plane
						back_plane = drawMoveNodeLines back_plane #(current_node) 10 5	link_parent_color link_child_color
						back_plane = drawNode current_node back_plane 1 1.0
						graph_bitmap.bitmap = drawBorder current_node link_parent_color back_plane 
					)catch()	
				)
				else
				(
					copy background_plane back_plane
					for i in multiple_selection do
					(
						TreeMatoGraph_Nodes[i].XPos += (pos-start_move_pos).x/scale_factor
						TreeMatoGraph_Nodes[i].YPos += (pos-start_move_pos).y/scale_factor
						back_plane = drawMoveNodeLines back_plane #(i) 10 5 link_parent_color link_child_color
						back_plane = drawNode i back_plane 1 1.0
					)
					graph_bitmap.bitmap = back_plane 				
				)	
				storeTreePosition()
				start_move_pos = pos
			)	
		)
		else
		(
			if (MButtonPressed and not keyboard.controlPressed) or (LButtonPressed and pan_mode.checked) then
			(
				pan_offset = pos - start_pos
				setSysCur #move
				if length pan_offset != 0 then
				(
					origin_offset += pan_offset
					start_pos = pos
					copy graph_bmp back_plane
					graph_bitmap.bitmap = drawAllNodes back_plane #() 10 5 0
				)	
			)			
			else
			(
				If not RbuttonPressed and not LbuttonPressed then
				(
					type_counter = 0
					current_node = NodeHitTest pos
					if current_node > 0 then
					(
						if current_node != current_highlight then
						(
							current_highlight = current_node
							copy graph_bitmap.bitmap back_plane
							back_plane = drawMoveNodeLines back_plane #(current_node) 10 5	link_parent_color link_child_color
							if zoom_mode.checked then
							(
								graph_bitmap.bitmap = drawNode current_node back_plane 1 zoom_factor
								displayNodeNames()	
							)	
							else
							(
								back_plane = drawNode current_node back_plane 1 1.0
								graph_bitmap.bitmap = drawBorder current_node link_parent_color back_plane 
								displayNodeNames()	
							)
							if show_parent_channel.checked then	showParentChannels current_node
							if show_child_channel.checked then showChildChannels current_node
						)	
					)	
					else
					(
						if current_highlight != 0 then
						(
							current_highlight = 0 
							copy graph_bmp background_plane
							graph_bitmap.bitmap = drawAllNodes background_plane #() 1 1 1
							clearNodeTypes()
							displayNodeNames()	
						)
					)	
				)
			)	
		)	
		et = timestamp()
		pushprompt ("TMG MOVE in "+ ((et-st) as string) + " ms.")
	)--end on mousemove
	
	
	
	
	fn getNewMapNode pos =
	(
		new_map = copy (materialBrowseDlg #maps)
		if new_map != undefined then
		(
			map_sample = renderMap new_map scale:100.0 size:[thumb_width*zoom_quality*zoom_factor ,thumb_height*zoom_quality*zoom_factor ] filter:true
			new_node = tree_node()
			new_node.Name = new_map.name
			new_node.XPos = (pos.x-thumb_width/2)/scale_factor
			new_node.YPos = (pos.y-thumb_height/2)/scale_factor
			new_node.Width = thumb_width
			new_node.Height = thumb_height
			new_node.ShadedColor = (color 200 255 200)
			new_node.Thumbnail = map_sample
			new_node.MaxNode = new_map
			new_node.Row = 0 
			new_node.Column = 0
			new_node.Selected = False
			append TreeMatoGraph_Nodes new_node		
			UiLog ("Created New Map : "+new_map.name+" ["+ classof new_map as string +"]" ) 2
		)
		else
		(
			UiLog "New Map Node Creation Canceled." 4
		)
	)
	
	fn getNewMatNode pos =
	(
		new_mat = copy (materialBrowseDlg #mats)
		if new_mat != undefined then
		(
			map_sample = TMG_renderMaterial new_mat (thumb_width*zoom_quality*zoom_factor)  (thumb_height*zoom_quality*zoom_factor )
			new_node = tree_node()
			new_node.Name = new_mat.name
			new_node.XPos = (pos.x-thumb_width/2)/scale_factor
			new_node.YPos = (pos.y-thumb_height/2)/scale_factor
			new_node.Width = thumb_width
			new_node.Height = thumb_height
			try(new_node.ShadedColor = new_mat.diffuse)catch(new_node.ShadedColor = (color 200 255 200))
			new_node.Thumbnail = map_sample
			new_node.MaxNode = new_mat
			new_node.Row = 0 
			new_node.Column = 0
			new_node.Selected = False			
			append TreeMatoGraph_Nodes new_node		
			UiLog ("Created New Mat : "+new_mat.name+" ["+ classof new_mat as string +"]" ) 2
		)
		else
		(
			UiLog "New Mat Node Creation Canceled." 4
		)
	)	
	
	
	fn LoadNodeInMeditor hit_node =
	(
		max mtledit
		setMeditMaterial 1 TreeMatoGraph_Nodes[hit_node].MaxNode
		medit.setActiveMtlSlot 1 true
		if auto_update.checked then registerMaterialPropertiesCallback()
	)
	
	
	
	
	-------------------------------------
	-- LEFT MOUSE BUTTON DOUBLECLICKED --
	-------------------------------------
	on TreeMatoGraph_rollout lbuttonDblClk pos do
	(
		local hit_node = NodeHitTest pos
		if hit_node > 0 then 
		(
			if keyboard.ControlPressed then
			(
				TreeMatoGraph_Nodes[hit_node].Collapsed = not TreeMatoGraph_Nodes[hit_node].Collapsed
				if TreeMatoGraph_Nodes[hit_node].Collapsed then collapseTree() else expandTree()
				storeAppDataVisible()
			)
			else
			(
				if quickEditEnabled then 
					OpenQuickEdit()
				else	
					LoadNodeInMeditor hit_node
			)	
		)	
		else
		(
			if TreeMatoGraph_Nodes.count == 0 then
			(
				mat = copy (materialBrowseDlg #mats)
				if mat != undefined then
					CreateNewRoot mat 			
				else
					UiLog "Material Tree Root Creation Failed!" 4		
			)
			else
			(
				getNewMapNode (pos-origin_offset)
				storeTreePosition()
				graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1	
				displayNodeNames()
			)	
		)
	)	
	on TreeMatoGraph_rollout moved pos do storePosition pos	
	
	on TreeMatoGraph_rollout resized size do 
	(
		new_graph_width = size.x
		new_graph_height = size.y
		ready_to_resize = false
	)	
	
	
	on show_node_names changed state do 
	(
		storeIniFile()
		displayNodeNames()
	)	
	on show_node_class changed state do 
	(
		storeIniFile()
		displayNodeNames()
	)	
	on show_parent_channel changed state do storeIniFile()
	on show_child_channel changed state do storeIniFile()	
	
	on callback_update_clock tick do 
	(
		if (new_graph_width != graph_width or new_graph_height != graph_height) and ready_to_resize then
		(
			if new_graph_width < 400 then new_graph_width = 400
			if new_graph_height < 200 then new_graph_height = 200
			graph_width = new_graph_width 
			graph_height = new_graph_height - 42
			storeIniFile()
			InitUtilityDialog()
			graph_bitmap.bitmap = drawAllNodes back_plane #() 1 1 1	
			displayNodeNames()
		)
		if TreeMatoGraph_StructureChanged then 
		(
			TreeMatoGraph_StructureChanged = false
			reloadMaterialTree()
		)
	
		if (timestamp()-TreeMatoGraph_PropertyChanged) > LastThumbnailUpdateTime  then
		(
			if progressive_update_current_node < TreeMatoGraph_Nodes.count then
			(
				progressive_update_current_node += 1
			)
			else
			(
				if progressive_update_current_pass < progressive_update_passes then
				(
					progressive_update_current_node = 1
					progressive_update_current_pass += 1
				)
				else
				(
					progressive_update_current_pass = 1
					progressive_update_current_node = 0
					TreeMatoGraph_PropertyChanged = 10^10
				)
			)
			if progressive_update_current_node > 0 then
			(
				UpdateSingleNodeThumbnail progressive_update_current_node (zoom_quality/(( 1+progressive_update_passes-progressive_update_current_pass) as float))
			)
		)
	)--end calback check
	
	on TreeMatoGraph_rollout close do
	(
		try(destroyDialog TreeMatoGraph_console)catch()
		try(DestroyDialog TreeMatoGraph_quickEdit_rollout)catch()
		try(closerolloutfloater TreeMatoGraph_options_floater)catch()
	)
	
	on zoomreset_button pressed do
	(
		scale_factor = 1.0
		origin_offset = [0.0,0.0]
		view_scale_factor.value = 100
		view_scale_update()
		UiLog ("Reset Pan And Zoom To Defaults.") 2 			
	)
	
	
)--end rollout


fn InitUtilityDialog =
(
	try(destroyDialog TreeMatoGraph_rollout)catch()
	gc light:true
 	InitializeGraphicsWindow()
	new_pos = restorePosition()
	createDialog TreeMatoGraph_rollout graph_width (graph_height+42) pos:new_pos escapeEnable:false style:#(#style_titlebar,#style_sysmenu,#style_resizing)  menu:TMG_RCMenu
--	registerViewWindow TreeMatoGraph_rollout
	TreeMatoGraph_rollout.DefineThumbLabel()
	TreeMatoGraph_rollout.DefineTypeLabel()
	TreeMatoGraph_rollout.defineColArray()
	TreeMatoGraph_rollout.UiLog "Initializing TMG UI..." 2
	new_graph_width = graph_width 
	new_graph_height = graph_height 
	restoreIniFile()
	if TreeMatoGraph_Nodes == undefined then TreeMatoGraph_Nodes = #()
	if TreeMatoGraph_Links == undefined then TreeMatoGraph_Links = #()
--	TreeMatoGraph_rollout.UiLog ("Ready.") 2
)
InitUtilityDialog()
unregisterMaterialPropertiesCallback()

if selection.count == 1 then 
(
	if $.material != undefined then
	(
		q = querybox ("Load Material ["+  $.material.name +"] from Selected Object?") title:"TreeMatoGraph"
		if q then
		(
			TreeMatoGraph_rollout.buildTree $.material
			TreeMatoGraph_rollout.restoreTreePosition()
		)	
	)	
)	
TreeMatoGraph_rollout.graph_bitmap.bitmap = TreeMatoGraph_rollout.drawAllNodes back_plane #() 1 1 1
TreeMatoGraph_rollout.displayNodeNames()
multiple_selection = #()
for i = 1 to TreeMatoGraph_Nodes.count do if TreeMatoGraph_Nodes[i].Selected then append multiple_selection i

TreeMatoGraph_rollout.UiLog "TMG Initialization Finished." 2

)--end script
